/* $Copyright$     NB: This is an auto-generated comment with copyright note below. DO NOT MODIFY OR REMOVE!
 * Copyright 2018 FUJITSU LIMITED
 * All rights reserved
 */
/* ******************************************************************
 *
 * Copyright 2018 FUJITSU LIMITED
 *
 * filename: smbus_inc.h
 * version:  8.40.08
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 *   02110-1301, USA.
 *
 * ******************************************************************/
#ifndef WITHOUT_SYSTEM_INCLUDES_ON_PRECOMPILE
#ifndef _SMBUS_INCLUDE_H
	#define _SMBUS_INCLUDE_H
	#ifndef LINUX_VERSION_CODE
		#include <linux/version.h>
	#endif	// LINUX_VERSION_CODE
	// We do not support kernel versions less than 2.6.32 (RHEL 6)
	#ifndef		KERNEL2632
		#define	KERNEL2632			 1
	#endif // KERNEL2632
	#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
		#ifndef		KERNEL30
			#define	KERNEL30		 1
		#endif		// KERNEL30
	#endif	// LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
	#if LINUX_VERSION_CODE >= KERNEL_VERSION(4,0,0)
		#ifndef		KERNEL40
			#define	KERNEL40		 1
		#endif		// KERNEL40
	#endif	// LINUX_VERSION_CODE >= KERNEL_VERSION(4,0,0)
	#include <linux/module.h>
	#include <linux/vmalloc.h>
	#include <linux/types.h>
	#include <linux/kernel.h>
	#include <linux/sched.h>
	#include <linux/slab.h>
	#include <linux/mm.h>
	#include <linux/string.h>
	#include <linux/errno.h>
	#include <linux/ioctl.h>
	#include <linux/delay.h>
	#include <linux/pci.h>
	#include <linux/pm.h>
	#include <asm/io.h>					// inb_p
	#include <linux/uaccess.h>			// copy_to_user/copy_from_user
	#include <linux/fs.h>
	#include <linux/spinlock.h>
	#include <linux/smp.h>
	// -------------------------------------------------------------------------
	#define mem_map_reserve(p)		set_bit(PG_reserved, &((p)->flags))
	#define mem_map_unreserve(p)	clear_bit(PG_reserved, &((p)->flags))
	#define DRIVER_PARAMETER(param,str,type,perm)	module_param(param, type, perm)
	// Avoid compiler problems on SLES with xen kernel
	// undef the macro VOID from hypercall.h
	//
	// Oktawian Krawczuk; 14.02.2017:
	//Is it still necessary ?
	//
	#ifdef VOID
	#undef VOID
	#endif
	//Is it still necessary ?
	// -------------------------------------------------------------------------
	MODULE_LICENSE("GPL");
	MODULE_AUTHOR("Fujitsu Technology Solutions");
	MODULE_INFO(supported, "yes");
	MODULE_DESCRIPTION("allow access to BIOS, SMBUS, and cpuid / msr registers");
	MODULE_INFO(device, "/dev/pci/smbus");
	MODULE_SUPPORTED_DEVICE("/dev/pci/smbus");
#endif // _SMBUS_INCLUDE_H
#endif  // WITHOUT_SYSTEM_INCLUDES_ON_PRECOMPILE
#ifndef MYMOD_ISKMPMODULE
#define MYMOD_ISKMPMODULE "yes"
#endif
#ifndef MYMOD_OBJDATE
#define MYMOD_OBJDATE "unknown"
#endif
#ifndef MYMOD_COMPILERVERSRION
#define MYMOD_COMPILERVERSRION "unknown"
#endif
#ifndef MYMOD_KERNELVERSION
#define MYMOD_KERNELVERSION "unknown"
#endif
#ifndef MYMOD_OSARCHITECTURE
#define MYMOD_OSARCHITECTURE "unknown"
#endif
#ifndef MYMOD_OSVERSION
#define MYMOD_OSVERSION "unknown"
#endif
#pragma pack (1)
typedef struct _IoctlData_ReadSmbus
{
 uint32_t DeviceAddress;
 uint32_t StartOffset;
} IOCTLDATA_READ_SMBUS, *P_IOCTLDATA_READ_SMBUS;
typedef struct _IoctlData_WriteSmbus
{
 uint32_t DeviceAddress;
 uint32_t StartOffset;
 uint32_t BytesToWrite;
 uint8_t WriteData[256];
} IOCTLDATA_WRITE_SMBUS, *P_IOCTLDATA_WRITE_SMBUS;
typedef struct _Smbus_MuxDeviceAddess
{
 uint8_t Address;
 uint8_t Offset;
 uint8_t Protocol;
 uint8_t AndMask;
 uint8_t OrMask;
 uint8_t Reserved[3];
} SMBUS_MUX_ADDR, *P_SMBUS_MUX_ADDR;
typedef struct _IoctlData_Smbus_OpenDevice
{
 uint8_t DeviceAddress;
 SMBUS_MUX_ADDR MuxAddr[1];
} IOCTLDATA_SMBUS_OPEN_DEVICE, *P_IOCTLDATA_SMBUS_OPEN_DEVICE;
typedef struct _IoctlData_Smbus_ReadDevice
{
 uint32_t DeviceHandle;
 uint32_t StartOffset;
} IOCTLDATA_SMBUS_READ_DEVICE, *P_IOCTLDATA_SMBUS_READ_DEVICE;
typedef struct _IoctlData_Smbus_WriteDevice
{
 uint32_t DeviceHandle;
 uint32_t StartOffset;
 uint32_t BytesToWrite;
 uint8_t WriteData[1];
} IOCTLDATA_SMBUS_WRITE_DEVICE, *P_IOCTLDATA_SMBUS_WRITE_DEVICE;
typedef struct _IoctlData_Smbus_MasterInfo
{
 uint16_t VendorId;
 uint16_t DeviceId;
 uint32_t BaseAddress;
} IOCTLDATA_SMBUS_MASTER_INFO, *P_IOCTLDATA_SMBUS_MASTER_INFO;
enum ChipsetType
{
 CS_UNKNOWN,
 CS_INTEL_PIIX4,
 CS_INTEL_ICH,
 CS_RCC_OSB4,
 CS_RCC_CSB5,
 CS_RCC_CSB6,
 CS_VIA_686A,
 CS_VIA_8233,
 CS_VIA_8237,
 CS_INTEL_PCH
};
typedef struct _IoctlData_Smbus_Chip
{
 uint32_t BaseAddress;
 uint16_t VendorId;
 uint16_t DeviceId;
 uint8_t Chipset;
 uint8_t BusNo;
 uint8_t DeviceNo;
 uint8_t FunctionNo;
} IOCTLDATA_SMBUS_CHIP, *P_IOCTLDATA_SMBUS_CHIP;
typedef struct _SmbiAddress
{
 uint32_t OSType;
 uint64_t CmdBufAddr;
 uint64_t RespBufAddr;
 uint64_t SmbiCall;
} SMBI_ADDRESS, *P_SMBI_ADDRESS;
typedef struct _SmbiRwBuffer
{
 uint8_t BufType;
 uint16_t NrOfBytes;
 uint8_t Data[256];
} SMBI_RW_BUF, *P_SMBI_RW_BUF;
typedef struct _IoctlData_GabiDetected
{
 uint32_t EntryPointPhysicalAddress;
 uint32_t EntryPointMapAddress;
 uint32_t EntryPointMapSize;
} IOCTLDATA_GABI_DETECTED, *P_IOCTLDATA_GABI_DETECTED;
typedef struct _IoctlData_MapPhysicalMemory
{
 uint32_t PhysicalAddressLow;
 uint32_t PhysicalAddressHigh;
 uint32_t Size;
} IOCTLDATA_MAP_PHYS_MEM, *P_IOCTLDATA_MAP_PHYS_MEM;
typedef struct _IoctlData_SmmiCmd
{
 uint16_t CmdResultCode;
 uint16_t Data;
} IOCTLDATA_SMMI_CMD, *P_IOCTLDATA_SMMI_CMD;
typedef struct _IoctlData_indexed_port_io
{
    uint8_t IndexPort;
    uint8_t IndexData;
    uint8_t DataPort;
    uint8_t DataData;
} IOCTLDATA_INDEXED_PORT_IO, *P_IOCTLDATA_INDEXED_PORT_IO;
typedef struct _IoctlData_generic_io
{
    uint32_t Address;
 uint32_t DataWidth;
    uint32_t WriteData;
} IOCTLDATA_GEN_IO, *P_IOCTLDATA_GEN_IO;
typedef struct _IoctlData_multiport_io_struct
{
    uint32_t Address;
 uint32_t Mode;
    uint32_t Data;
} IOCTLDATA_MULTIPORT_IO_ELEM, *P_IOCTLDATA_MULTIPORT_IO_ELEM;
typedef struct _IoctlData_multiport_io
{
    uint32_t NumberElements;
 IOCTLDATA_MULTIPORT_IO_ELEM Element[1];
} IOCTLDATA_MULTIPORT_IO, *P_IOCTLDATA_MULTIPORT_IO;
typedef struct _IoctlData_PCI_get_conf_from_id
{
 uint16_t VendorId;
 uint16_t DeviceId;
 uint32_t StartOffset;
} IOCTLDATA_PCI_GET_CONF_FROM_ID, *P_IOCTLDATA_PCI_GET_CONF_FROM_ID;
typedef struct _IoctlData_PCI_get_conf_from_loc
{
 uint32_t Bus;
 uint32_t Device;
 uint32_t Function;
 uint32_t StartOffset;
} IOCTLDATA_PCI_GET_CONF_FROM_LOC, *P_IOCTLDATA_PCI_GET_CONF_FROM_LOC;
typedef struct _IoctlData_PCI_return_conf_from_loc
{
 uint32_t Bus;
 uint32_t Device;
 uint32_t Function;
 uint8_t ConfigData[4];
} IOCTLDATA_PCI_RETURN_CONF_FROM_LOC, *P_IOCTLDATA_PCI_RETURN_CONF_FROM_LOC;
enum CPUERR_ERROR_TYPE
{
 CPUERR_TYPE_NO_ERROR,
 CPUERR_TYPE_UNCLASSIFIED,
 CPUERR_TYPE_MICROCODE_PARITY,
 CPUERR_TYPE_EXTERNAL,
 CPUERR_TYPE_FRC_ERROR,
 CPUERR_TYPE_INT_UNCLASSIFIED,
 CPUERR_TYPE_TLB_ERROR,
 CPUERR_TYPE_CACHE_ERROR,
 CPUERR_TYPE_BUS_ERROR
};
enum CPUERR_TRANSACTION_TYPE
{
 CPUERR_XTYPE_INSTRUCTION,
 CPUERR_XTYPE_DATA,
 CPUERR_XTYPE_GENERIC
};
enum CPUERR_CACHE_LEVEL
{
 CPUERR_CACHELEVEL_0,
 CPUERR_CACHELEVEL_1,
 CPUERR_CACHELEVEL_2,
 CPUERR_CACHELEVEL_GENERIC
};
enum CPUERR_REQUEST_TYPE
{
 CPUERR_REQTYPE_GENERIC_ERR,
 CPUERR_REQTYPE_GENERIC_RD,
 CPUERR_REQTYPE_GENERIC_WR,
 CPUERR_REQTYPE_DATA_RD,
 CPUERR_REQTYPE_DATA_WR,
 CPUERR_REQTYPE_FETCH,
 CPUERR_REQTYPE_PREFETCH,
 CPUERR_REQTYPE_EVICTION,
 CPUERR_REQTYPE_SNOOP
};
typedef struct _IoctlData_CorrCpuError
{
 uint8_t ErrorType;
 uint8_t Overflow;
 uint8_t Uncorrectable;
 uint8_t Bank;
 uint16_t ErrorCode;
 uint16_t Align1;
 uint32_t AddressLow;
 uint32_t AddressHigh;
 uint64_t IA32MCiStatus;
 uint8_t CacheLevel;
 uint8_t RequestType;
 uint8_t TransactionType;
 uint8_t ParticipationLevel;
 uint8_t Timeout;
 uint8_t MemIo;
 uint16_t LogicalCpuNumber;
} IOCTLDATA_CORR_CPU_ERROR, *P_IOCTLDATA_CORR_CPU_ERROR;
typedef struct _IoctlData_CpuApicId_BootCpu
{
 uint8_t LocalApicId;
 uint8_t IsBootCpu;
 uint8_t LogicalCpuNumber;
 uint8_t Align;
} IOCTLDATA_CPU_APICID_BOOT_CPU, *P_IOCTLDATA_CPU_APICID_BOOT_CPU;
typedef struct _IoctlData_CpuApicId_Ex
{
 uint32_t LogicalCpuNumber;
 uint32_t LocalApicId;
 uint32_t Reserved1;
 uint8_t IsBootCpu;
 uint8_t xApicGlobalEnable;
 uint8_t x2ApicMode;
 uint8_t Reserved2;
} IOCTLDATA_CPU_APICID_EX, *P_IOCTLDATA_CPU_APICID_EX;
#pragma pack ()
#pragma pack (1)
typedef struct _LA_Driver_IoCtrl_
{
 unsigned long long pInBuffer;
 unsigned long long pOutBuffer;
 unsigned int InBufferSize;
 unsigned int OutBufferSize;
 unsigned int ReturnedBytes;
 int Success;
} LA_DRIVER_IOCTRL;
typedef struct _Smbus_Driver_Info_Hdr
{
 unsigned int VersionOfThisIoctl;
 unsigned int CmdNumberOfThisIoctl;
 unsigned int SizeOfInOutBuffer;
 unsigned int Reserved1;
 unsigned long long pInOutBuffer;
 int Success;
 unsigned int Reserved2;
} IOCTLDATA_SMBUS_DRIVER_INFO_HDR, *P_IOCTLDATA_SMBUS_DRIVER_INFO_HDR;
typedef struct _Smbus_Driver_Info
{
 unsigned int OSKernelVersionCode;
 unsigned int Reserved2b;
 unsigned int Reserved2c;
 unsigned int Reserved2d;
 unsigned int smbus_VersionCode;
 unsigned int smbus_ArchMode;
 unsigned int smbus_ArchXEN;
 unsigned int smbus_ArchFacil;
 unsigned int RequestorVersion;
 unsigned int Reserved3 [3];
 unsigned char smbus_IsSmbiHwFound;
 unsigned char smbus_IsBapiHwFound;
 unsigned char smbus_IsGabiHwFound;
 unsigned char smbus_IsSmbusHwFound;
 unsigned char smbus_IsBusIoHwFound;
 unsigned char smbus_IsCpuErrHwFound;
 unsigned char smbus_IsCpuApicHwFound;
 unsigned char smbus_IsCpuInfoHwFound;
 unsigned char Reserved4 [8];
 unsigned int smbus_MajorDeviceNumber;
 unsigned int smbus_IsKmpModule;
 unsigned int Reserved5 [2];
 unsigned int Reserved6 [4];
 unsigned char RequestorName [32];
 unsigned char smbus_Name [32];
 unsigned char smbus_SrcVersion [64];
 unsigned char smbus_SrcDate [64];
 unsigned char smbus_ObjDate [64];
 unsigned char smbus_OsArchitecture [32];
 unsigned char smbus_OsVersion [64];
 unsigned char smbus_CompilerVersion [128];
 unsigned char smbus_KernelVersion [128];
 unsigned char Reserved7 [32];
 unsigned char SV_SYSTEM [32];
 unsigned char SV_OS [128];
 unsigned char SV_NICKNAME [32];
 unsigned char smbus_ErrorReturnString [128];
 unsigned char Reserved9 [256];
} IOCTLDATA_SMBUS_DRIVER_INFO, *P_IOCTLDATA_SMBUS_DRIVER_INFO;
#pragma pack ()
typedef struct _CPU_ID_regs
{
 unsigned int eax;
 unsigned int ebx;
 unsigned int ecx;
 unsigned int edx;
} CPUIDRegs;
typedef struct _IoctlData_Cpu_Info
{
 unsigned char LogicalCpuNumber;
 unsigned char Align[7];
 int DenseCpuNr;
 int SparseCpuNr;
 int regs1Valid;
 int regs2Valid;
 int regs3Valid;
 int regs4Valid;
 int BrandStringValid;
 int NrCoresAMDValid;
 int MachineCheckArchitectureSupported;
 int LocalApicSupported;
 int PrimaryLogicalCpu;
 unsigned int LocalApicIdInitial;
 unsigned int NumberLogicalCpus;
 unsigned short NrCores;
 unsigned short Vendor;
 unsigned char Reserved1[8];
 CPUIDRegs regs0;
 CPUIDRegs regs1;
 CPUIDRegs regs2;
 CPUIDRegs regs3;
 CPUIDRegs regs4;
 CPUIDRegs MaxExtentions;
 CPUIDRegs BrandString1;
 CPUIDRegs BrandString2;
 CPUIDRegs BrandString3;
 CPUIDRegs NrCoresAMD;
 int BootstrapCpu;
 int ApicGlobalEnable;
 int x2ApicMode;
 int ApicIdValid;
 unsigned int ApicId;
 unsigned int Unused2;
 unsigned long long ApicBaseMsr;
 unsigned long long ApicBaseAddress;
 unsigned long long x2ApicLocalApicId;
 unsigned long long Unused4;
} IOCTLDATA_CPU_INFO, *P_IOCTLDATA_CPU_INFO;
typedef signed int INT_PTR, *PINT_PTR;
#define ASMX86(args...) asm(args)
#define PUSH_RAX "push %rax"
#define PUSH_RBX "push %rbx"
#define PUSH_RCX "push %rcx"
#define PUSH_RDX "push %rdx"
#define POP_RAX "pop  %rax"
#define POP_RBX "pop  %rbx"
#define POP_RCX "pop  %rcx"
#define POP_RDX "pop  %rdx"
#define RESET_RCX "mov  $0x0,%rcx"
#define PUSH_RRDI "push %%rdi"
#define PUSH_RRSI "push %%rsi"
#define PUSH_RRDX "push %%rdx"
#define PUSH_RRCX "push %%rcx"
#define POP_RRDI "pop  %rdi"
#define POP_RRSI "pop  %rsi"
#define POP_RRDX "pop  %rdx"
#define POP_RRCX "pop  %rcx"
#pragma pack(1)
typedef struct _Device_Address_Data
{
 IOCTLDATA_SMBUS_OPEN_DEVICE iod_open;
 SMBUS_MUX_ADDR muxdevadr[10];
} SMBUS_DEVICE_ADDRESS_DATA_ST;
#pragma pack()
extern void * OpenDevicesPersist[];
extern SMBUS_DEVICE_ADDRESS_DATA_ST SmBus_DAD_Buff [];
extern unsigned int smbus_ReadData(unsigned char DeviceAddress, unsigned char StartOffset, unsigned char * pReturnBuffer, unsigned int BytesToRead);
extern unsigned int smbus_WriteData(unsigned char DeviceAddress, unsigned char StartOffset, unsigned char * pWriteData, unsigned int BytesToWrite);
extern int smbus_OpenDevice(unsigned int * pDeviceHandle, SMBUS_DEVICE_ADDRESS_DATA_ST *psmdev, unsigned int size);
extern int smbus_CloseDevice(unsigned int DeviceHandle);
extern int smbus_ReadDevice(unsigned int DeviceHandle, unsigned char Offset, unsigned int BytesToRead, unsigned char * pReturnBuffer, unsigned int * pBytesRead);
extern int smbus_WriteDevice (unsigned int DeviceHandle, unsigned char Offset, unsigned int BytesToWrite, unsigned char * pWriteBuffer);
extern int smbus_ReadByte(unsigned char DeviceAddress, unsigned char Offset, unsigned char * pData, int NotUseOffset);
extern int smbus_WriteByte(unsigned char DeviceAddress, unsigned char Offset, unsigned char Data, int NotUseOffset);
typedef void (*SMBI_CMD_ROUTINE)(void);
extern void * OpenDevices[];
typedef struct _cpu_id_regs
{
 unsigned int eax;
 unsigned int ebx;
 unsigned int ecx;
 unsigned int edx;
} CpuIdRegs;
typedef struct _cpu_info_
{
 int DenseCpuNr;
 int SparseCpuNr;
 int regs1Valid;
 int regs2Valid;
 int regs3Valid;
 int regs4Valid;
 int BrandStringValid;
 int NrCoresAMDValid;
 int MachineCheckArchitectureSupported;
 int LocalApicSupported;
 int PrimaryLogicalCpu;
 unsigned int LocalApicIdInitial;
 unsigned int NumberLogicalCpus;
 unsigned short NrCores;
 unsigned short Vendor;
 unsigned char Reserved1[8];
 CpuIdRegs regs0;
 CpuIdRegs regs1;
 CpuIdRegs regs2;
 CpuIdRegs regs3;
 CpuIdRegs regs4;
 CpuIdRegs MaxExtentions;
 CpuIdRegs BrandString1;
 CpuIdRegs BrandString2;
 CpuIdRegs BrandString3;
 CpuIdRegs NrCoresAMD;
 int BootstrapCpu;
 int ApicGlobalEnable;
 int x2ApicMode;
 int ApicIdValid;
 unsigned int ApicId;
 unsigned int Unused2;
 unsigned long long ApicBaseMsr;
 unsigned long long ApicBaseAddress;
 unsigned long long x2ApicLocalApicId;
 unsigned int * ApicVirtualAddress;
} CpuInfo;
typedef struct _cpu_error_info_
{
 void *pCpuError;
 int DenseCpuNr;
 unsigned long long McgCap;
 unsigned long long McgStatus;
 int NrErrorBanks;
 unsigned int MsrAddrMCiStatus;
 unsigned int MsrAddrMCiAddr;
 int ErrorAvailable;
} CpuErrorInfo;
#pragma pack (1)
typedef struct _GABI_ENTRY_POINT
{
 uint8_t ucSignature[8];
 uint8_t ucLength;
 uint8_t ucCheckSum;
 uint8_t ucVersion;
 uint8_t reserved1[5];
 uint16_t usApi16Ofs;
 uint32_t ulApi16Seg;
 uint32_t ulEntryPoint32;
 uint64_t paEntryPoint64;
 uint8_t VendorSpecific[1];
} GABI_ENTRY_POINT, *P_GABI_ENTRY_POINT;
typedef struct _GABI_CONTROL_BUFFER
{
 uint16_t AllocatedBufferSize;
 uint16_t ServiceCategoryCode;
 uint16_t ServiceCode;
 uint16_t GeneralStatus;
 uint16_t ErrorCode;
 uint16_t ActionCode;
 uint16_t SubFunction;
 uint16_t ExtraStatus;
 uint8_t Reserved[16];
 uint8_t BiosScratchBuffer[992];
} GABI_CONTROL_BUFFER, *P_GABI_CONTROL_BUFFER;
typedef struct _GABI_DATA_BUFFER_COMMON_HEADER
{
 uint16_t AllocatedBufferSize;
 uint8_t Data[1];
} GABI_DATA_BUFFER_COMMON_HEADER, *P_GABI_DATA_BUFFER_COMMON_HEADER;
typedef struct _GABI_DATA_BUFFER_HEADER
{
 uint16_t AllocatedBufferSize;
 uint16_t StructureVersion;
 uint32_t TransactionHandle;
 uint8_t Data[1];
} GABI_DATA_BUFFER_HEADER, *P_GABI_DATA_BUFFER_HEADER;
typedef struct _GABI_DATA_BUFFER_DESCR_HEADER
{
 uint16_t AllocatedBufferSize;
 uint16_t StructureVersion;
 uint32_t TransactionHandle;
 uint64_t DataSize;
 uint8_t Data[1];
} GABI_DATA_BUFFER_DESCR_HEADER, *P_GABI_DATA_BUFFER_DESCR_HEADER;
typedef void (*GABI_CALL)(uint32_t InBuffer, uint32_t OutBuffer, uint32_t ControlBuffer);
typedef struct _GABISYS_DATA_DESCRIPTOR
{
 uint64_t BlockAddressPhysical;
 uint64_t BlockSize;
} GABISYS_DATA_DESCRIPTOR, *P_GABI_DATA_DESCRIPTOR;
#pragma pack ()
typedef struct _PHYSICAL_MEMORY_DESCRIPTOR
{
 unsigned long AllocatedSize;
 unsigned char *pVirtualAddress;
 unsigned long long PhysicalAddress;
} PHYSICAL_MEMORY_DESCRIPTOR;
typedef struct _PHYSICAL_MEMORY_DESCRIPTOR_LIST
{
 INT_PTR ActNumberOfEntries;
 INT_PTR MaxEntries;
 PHYSICAL_MEMORY_DESCRIPTOR Descriptor[3];
 struct _PHYSICAL_MEMORY_DESCRIPTOR_LIST *pNext;
} PHYSICAL_MEMORY_DESCRIPTOR_LIST;
static int smbusArchMode = 0x00000000;
static int smbusArchXEN = 0x00000000;
static int smbusArchFacil = 0x00000000;
#ifdef virt_to_bus
#define VIRT_TO_PHYS virt_to_bus
#define PHYS_TO_VIRT bus_to_virt
#else
#define VIRT_TO_PHYS virt_to_phys
#define PHYS_TO_VIRT phys_to_virt
#endif
#ifdef virt_to_machine
#define VIRT_TO_MACHINE virt_to_machine
#else
#define VIRT_TO_MACHINE virt_to_bus
#endif
#if defined CONFIG_XEN && defined page_to_pseudophys
#define PAGE_TO_PSEUDOPHYS(x) page_to_pseudophys(x)
#define VIRT_TO_PAGE(x) virt_to_page(x)
#else
#define PAGE_TO_PSEUDOPHYS(x) (x)
#define VIRT_TO_PAGE(x) (x)
#endif
#if defined CONFIG_XEN && defined virt_to_machine
#define SMBUS_DMA_MEM_GET(Dev, Size, Dummy, Flags) dma_alloc_coherent((Dev), (Size), (Dummy), (Flags))
#define SMBUS_DMA_MEM_FREE(Dev, Size, pVirt, BusVirt) dma_free_coherent((Dev), (Size), (pVirt), (BusVirt))
#else
#define SMBUS_DMA_MEM_GET(Dev, Size, Dummy, Flags) __get_free_page((Flags))
#define SMBUS_DMA_MEM_FREE(Dev, Size, pVirt, BusVirt) free_page((ulong)(pVirt))
#endif
#define SMBUS_MY_DMA_DEVICE NULL
#define DRIVER_REMAP_RANGE_INTF 0x00000400
#define DRIVER_REMAP_RANGE(vma,va,pfn,vs,pr) remap_pfn_range((vma), (va), ((pfn) >> PAGE_SHIFT), (vs), (pr))
#ifdef KERNEL2632
#ifdef KERNEL30
#ifdef KERNEL40
#define DRIVER_KERNEL_MODE (0x01000000 | 0x02000000 | 0x04000000)
#else
#define DRIVER_KERNEL_MODE (0x01000000 | 0x02000000)
#endif
#else
#define DRIVER_KERNEL_MODE (0x01000000)
#endif
#define DRIVER_SET_OWNER do {smbus_fops.owner = THIS_MODULE;} while (0)
#define DRIVER_SAVE_FLAGS(flags) local_save_flags(flags)
#define DRIVER_DISABLE_IRQ() local_irq_disable()
#define DRIVER_FLAGS_RESTORE(flags) local_irq_restore(flags)
#define CPU_NUMBER_MAP(sparse) (sparse)
#define SMP_NUM_CPUS num_online_cpus()
#define PREEMPT_ENABLE preempt_enable()
#define PREEMPT_DISABLE preempt_disable()
#endif
#ifdef KERNEL30
#define PCI_FIND_DEVICE pci_get_device
#else
#define PCI_FIND_DEVICE pci_find_device
#endif
#ifdef KERNEL30
#define DRIVER_FOPS .unlocked_ioctl = smbus_ioctl, .compat_ioctl = smbus_ioctl_compat, .open = smbus_open, .release = smbus_release
#else
#define DRIVER_FOPS .ioctl = smbus_ioctl, .compat_ioctl = smbus_ioctl_compat, .open = smbus_open, .release = smbus_release
#endif
#ifdef PAGE_KERNEL_EXEC
#define SMBUS_PAGE_KERNEL_EXEC PAGE_KERNEL_EXEC
#else
#ifdef PAGE_KERNEL_EXECUTABLE
#define SMBUS_PAGE_KERNEL_EXEC PAGE_KERNEL_EXECUTABLE
#else
#define SMBUS_PAGE_KERNEL_EXEC PAGE_KERNEL
#endif
#endif
#define VMALLOC_EXEC(size) __vmalloc((size), GFP_KERNEL | __GFP_HIGHMEM, SMBUS_PAGE_KERNEL_EXEC)
static unsigned long jiffies0 = 0;
static short smbusDebug = 0;
static char *smbus_SrcVersion = "8.40.08";
static char *smbus_SrcDate = "2018/06/21-11:40";
static char *smbus_IsKmpModule = MYMOD_ISKMPMODULE;
static char *smbus_ObjDate = MYMOD_OBJDATE;
static char *smbus_CompilerVersion = MYMOD_COMPILERVERSRION;
static char *smbus_KernelVersion = MYMOD_KERNELVERSION;
static char *smbus_OsArchitecture = MYMOD_OSARCHITECTURE;
static char *smbus_OsVersion = MYMOD_OSVERSION;
static IOCTLDATA_SMBUS_DRIVER_INFO_HDR smbus_DriverInfoHdr;
static IOCTLDATA_SMBUS_DRIVER_INFO smbus_DriverInfo;
int IsSmbusHwFound = 0;
int IsGabiHwFound = 0;
int IsBusIoHwFound = 1;
int IsCpuErrHwFound = 1;
int IsCpuApicHwFound = 1;
int IsCpuInfoHwFound = 1;
typedef void (*GABI_CMD_ROUTINE)(unsigned long InBuffer, unsigned long OutBuffer, unsigned long ControlBuffer);
typedef void (*GABI_CMD_ROUTINE_VOID)(void);
static noinline void DetectBiosInterfaces (void);
static noinline int FindGabi (void);
static noinline unsigned char * FindSignature (unsigned char * pStartAddress, unsigned int Size, unsigned char * pSignature, unsigned int SignatureSize, unsigned char ScanBoundary);
static noinline void* smbus_DMA_Memory_Alloc (unsigned int Size);
static noinline void smbus_DMA_Memory_Free (void *pVirt, unsigned int Size);
static noinline int AllocateBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, unsigned int bufferSize);
static noinline void FreeBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr);
static noinline int GabiExecuteCommand (unsigned char * pInBuffer, unsigned int InDataSize, unsigned char * pOutBuffer, unsigned int OutBufferSize, unsigned int *ReturnDataSize);
static noinline int GabiPrepareGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pInputDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList, const char * pBufferName, int copyRequestData);
static noinline int GabiReturnGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pReturnDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList);
static noinline PHYSICAL_MEMORY_DESCRIPTOR_LIST *GabiAllocateDescriptorList(void);
static noinline void GabiFreeDescriptorLists (PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList);
static noinline void DumpBytes (unsigned char traceLevel, unsigned char * pTitle, unsigned char *pMemory, size_t nrBytes);
  noinline void smbus_CallGabi (unsigned long InBuffer, unsigned long OutBuffer, unsigned long ControlBuffer, GABI_CMD_ROUTINE_VOID GabiEx);
static noinline void ReadFromIndexedPort (IOCTLDATA_INDEXED_PORT_IO *portio);
static noinline void WriteToIndexedPort (IOCTLDATA_INDEXED_PORT_IO *portio);
static noinline int smbus_open (struct inode *inode, struct file *file);
static noinline int smbus_release (struct inode *inode, struct file *file);
  noinline long smbus_ioctl_compat (struct file *file, unsigned int cmd, unsigned long arg);
#ifdef KERNEL30
static noinline long smbus_ioctl (struct file *file, unsigned int cmd, unsigned long arg);
static noinline long smbus_ioctl_body (struct file *file, unsigned int cmd, unsigned long arg);
#else
static noinline int smbus_ioctl (struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg);
static noinline int smbus_ioctl_body (struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg);
#endif
static noinline void free_all (void);
static noinline int smbus_DetermineEnvironment (void);
  noinline int init_module (void);
  noinline void cleanup_module (void);
static noinline void smbus_InitDriverInfo (void);
static char *SMBUS_DEV = "smbus";
static int smbus_major = 0;
#ifdef KERNEL30
#ifndef DECLARE_MUTEX
#define DECLARE_MUTEX(name) DEFINE_SEMAPHORE(name)
#define init_MUTEX(sem) sema_init(sem, 1)
#define init_MUTEX_LOCKED(sem) sema_init(sem, 0)
#endif
static DECLARE_MUTEX(smbus_driver_big_lock);
#define GET_BIG_DRIVER_LOCK down(&smbus_driver_big_lock)
#define FREE_BIG_DRIVER_LOCK up(&smbus_driver_big_lock)
#else
#define GET_BIG_DRIVER_LOCK
#define FREE_BIG_DRIVER_LOCK
#endif
static DECLARE_MUTEX(smbus_mutex);
#define SMP_CALL_FUNCTION(func, arg, ignore, wait) smp_call_function((func), (arg), (wait))
static CpuInfo smbus_cpuinfotable[1024 + 1];
    noinline void smbus_ReadCpuInfo_callback (void *pent);
static noinline void smbus_do_ReadCpuInfo (CpuInfo *pentry);
static noinline void smbus_FillCpuInfoTable (void);
static noinline unsigned long long smbus_ReadMsr (unsigned int address);
static noinline void smbus_WriteMsr (unsigned int address, unsigned long long data);
static noinline void smbus_CpuId (unsigned int address, CpuIdRegs *regs);
    noinline void smbus_GetCpuError_callback (void *pCpuErrInfo);
static noinline void smbus_do_GetCpuError (CpuErrorInfo *pCpuErrInfo);
static noinline void smbus_ReadCpuErrorInfo (CpuErrorInfo *pCpuErrInfo);
DRIVER_PARAMETER(smbusDebug, "h", short, S_IRUSR | S_IWUSR);
MODULE_PARM_DESC(smbusDebug, "    0 - debug off; , >0 - debug on)");
DRIVER_PARAMETER(smbusArchMode, "i", int, S_IRUSR);
MODULE_PARM_DESC(smbusArchMode, " This bit field reflects the current architecture mode");
DRIVER_PARAMETER(IsSmbusHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsSmbusHwFound, "   true if SMBUS  Hardware available)");
DRIVER_PARAMETER(IsBusIoHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsBusIoHwFound, "   true if BUS IO Hardware available)");
DRIVER_PARAMETER(IsGabiHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsGabiHwFound, "    true if GABI Firmware available)");
DRIVER_PARAMETER(IsCpuApicHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsCpuApicHwFound, " true if CPU Apic Information available)");
DRIVER_PARAMETER(IsCpuErrHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsCpuErrHwFound, "  true if CPU Error detection available)");
DRIVER_PARAMETER(IsCpuInfoHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsCpuInfoHwFound, " true if CPU Information available)");
enum ChipsetType my_Chipset = CS_UNKNOWN;
unsigned int my_SMBusBaseAddress = 0;
unsigned short my_VendorId = 0;
unsigned short my_DeviceId = 0;
unsigned char my_BusNo = 0;
unsigned char my_DeviceNo = 0;
unsigned char my_FunctionNo = 0;
void * OpenDevices[256] = {};
void * OpenDevicesPersist[256] = {};
SMBUS_DEVICE_ADDRESS_DATA_ST SmBus_DAD_Buff [256] = {};
static char *m_pGabiSearchAddr = NULL;
static GABI_ENTRY_POINT *m_pGabiBase = NULL;
static GABI_CMD_ROUTINE m_fGabiExec = NULL;
static void *m_pVirtMemoryGABI = NULL;
static unsigned char *m_pInOutBufferGABI = NULL;
static PHYSICAL_MEMORY_DESCRIPTOR m_GabiControlBuffer;
static PHYSICAL_MEMORY_DESCRIPTOR m_GabiRequestBuffer;
static PHYSICAL_MEMORY_DESCRIPTOR m_GabiResponseBuffer;
static PHYSICAL_MEMORY_DESCRIPTOR m_pGABIStaticPage;
static unsigned char *m_pFreeVirtStMemGABI = NULL;
static unsigned long m_pFreePhysStMemGABI = 0;
static unsigned int m_FreeStMemGABI = 0;
static noinline int smbus_open(struct inode *inode, struct file *file)
{
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_open(0x%p,0x%p)\n", (int)(jiffies-jiffies0), inode, file); } while (0);
 return 0;
}
static noinline int smbus_release(struct inode *inode, struct file *file)
{
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_release(0x%p,0x%p)\n", (int)(jiffies-jiffies0), inode, file); } while (0);
 return 0;
}
static noinline int smbus_DetermineEnvironment(void)
{
 if (smbusArchMode == 0x00000000) {
  smbusArchMode |= DRIVER_REMAP_RANGE_INTF;
  smbusArchMode |= DRIVER_KERNEL_MODE;
 } else {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Environment: has been determined by insmod\n", (int)(jiffies-jiffies0)); } while (0);
 }
#ifdef CONFIG_XEN
 smbusArchXEN = 0x00000001;
#endif
 smbusArchFacil |= 0x00000010;
 smbusArchFacil |= 0x00001000;
#ifdef virt_to_bus
 smbusArchFacil |= 0x00000020;
#endif
#ifdef virt_to_machine
 smbusArchFacil |= 0x00000040;
#endif
#if defined CONFIG_XEN && defined page_to_pseudophys
 smbusArchFacil |= 0x00000100;
 smbusArchFacil |= 0x00000200;
#endif
#if defined CONFIG_XEN && defined virt_to_machine
 smbusArchFacil |= 0x00002000;
#endif
 if (smbusDebug> 0)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Source Version          = %s\n", (int)(jiffies-jiffies0), smbus_SrcVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Source Date             = %s\n", (int)(jiffies-jiffies0), smbus_SrcDate); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Is KMP Module           = %s\n", (int)(jiffies-jiffies0), smbus_IsKmpModule); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Object Date             = %s\n", (int)(jiffies-jiffies0), smbus_ObjDate); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Compiler Version        = %s\n", (int)(jiffies-jiffies0), smbus_CompilerVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: My Kernel Version       = %s\n", (int)(jiffies-jiffies0), smbus_KernelVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: OS Architecture         = %s\n", (int)(jiffies-jiffies0), smbus_OsArchitecture); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: OS Version              = %s\n", (int)(jiffies-jiffies0), smbus_OsVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: OS Linux Version Code   = 0x%08X\n", (int)(jiffies-jiffies0), LINUX_VERSION_CODE); } while (0);
  if (smbusArchMode & 0x01000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 2.6.32 mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x02000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 3.0    mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x04000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 4.0    mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x00000400) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: PFN_REMAP_INTF     is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchXEN & 0x00000001) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: XEN kernel         detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchXEN); } while (0);
  if (smbusArchFacil & 0x00000010) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_phys       detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000020) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_bus        detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000040) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_machine    detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000100) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: page_to_pseudophys detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000200) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_page       detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00001000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: get_free_page mode detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00002000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: dma_coherent  mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
 }
 return 0;
}
static noinline void smbus_InitDriverInfo (void)
{
 unsigned int DriverStep = 0;
 unsigned int DriverMajor = 0;
 unsigned int DriverMinor = 0;
 IOCTLDATA_SMBUS_DRIVER_INFO_HDR *pHdr = &smbus_DriverInfoHdr;
 IOCTLDATA_SMBUS_DRIVER_INFO *pBuf = &smbus_DriverInfo;
 memset ((unsigned char *)pHdr, 0, sizeof(IOCTLDATA_SMBUS_DRIVER_INFO_HDR));
 memset ((unsigned char *)pBuf, 0, sizeof(IOCTLDATA_SMBUS_DRIVER_INFO));
 pHdr->VersionOfThisIoctl = (unsigned int) 0x00000001;
 pHdr->CmdNumberOfThisIoctl = (unsigned int) 0xFF;
 pHdr->SizeOfInOutBuffer = (unsigned int) sizeof(IOCTLDATA_SMBUS_DRIVER_INFO);
 pBuf->OSKernelVersionCode = (unsigned int) LINUX_VERSION_CODE;
 sscanf(smbus_SrcVersion, "%d.%d-%d", &DriverStep, &DriverMajor, &DriverMinor);
 pBuf->smbus_VersionCode = (unsigned int) ((DriverStep<<16) | (DriverMajor<<8) | (DriverMinor));
 pBuf->smbus_ArchMode = (unsigned int) smbusArchMode;
 pBuf->smbus_ArchXEN = (unsigned int) smbusArchXEN;
 pBuf->smbus_ArchFacil = (unsigned int) smbusArchFacil;
 pBuf->smbus_IsGabiHwFound = (unsigned char) IsGabiHwFound;
 pBuf->smbus_IsSmbusHwFound = (unsigned char) IsSmbusHwFound;
 pBuf->smbus_IsBusIoHwFound = (unsigned char) IsBusIoHwFound;
 pBuf->smbus_IsCpuErrHwFound = (unsigned char) IsCpuErrHwFound;
 pBuf->smbus_IsCpuApicHwFound = (unsigned char) IsCpuApicHwFound;
 pBuf->smbus_IsCpuInfoHwFound = (unsigned char) IsCpuInfoHwFound;
 pBuf->smbus_MajorDeviceNumber = (unsigned int) smbus_major;
 if (strcmp(smbus_IsKmpModule, "no") == 0)
 {
  pBuf->smbus_IsKmpModule = (unsigned int) 0;
 } else {
  pBuf->smbus_IsKmpModule = (unsigned int) 1;
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: smbus Version Code = 0x%08X\n", (int)(jiffies-jiffies0), pBuf->smbus_VersionCode); } while (0);
 snprintf(pBuf->smbus_Name, sizeof(pBuf->smbus_Name), "%s", "SMBUS-Driver");
 pBuf->smbus_Name[sizeof(pBuf->smbus_Name) - 1] = '\0';
 strncpy(pBuf->smbus_SrcVersion, smbus_SrcVersion, sizeof(pBuf->smbus_SrcVersion));
 pBuf->smbus_SrcVersion[sizeof(pBuf->smbus_SrcVersion) - 1] = '\0';
 strncpy(pBuf->smbus_SrcDate, smbus_SrcDate, sizeof(pBuf->smbus_SrcDate));
 pBuf->smbus_SrcDate[sizeof(pBuf->smbus_SrcDate) - 1] = '\0';
 strncpy(pBuf->smbus_ObjDate, smbus_ObjDate, sizeof(pBuf->smbus_ObjDate));
 pBuf->smbus_ObjDate[sizeof(pBuf->smbus_ObjDate) - 1] = '\0';
 strncpy(pBuf->smbus_OsArchitecture, smbus_OsArchitecture, sizeof(pBuf->smbus_OsArchitecture));
 pBuf->smbus_OsArchitecture[sizeof(pBuf->smbus_OsArchitecture) - 1] = '\0';
 strncpy(pBuf->smbus_OsVersion, smbus_OsVersion, sizeof(pBuf->smbus_OsVersion));
 pBuf->smbus_OsVersion[sizeof(pBuf->smbus_OsVersion) - 1] = '\0';
 strncpy(pBuf->smbus_CompilerVersion, smbus_CompilerVersion, sizeof(pBuf->smbus_CompilerVersion));
 pBuf->smbus_CompilerVersion[sizeof(pBuf->smbus_CompilerVersion) - 1] = '\0';
 strncpy(pBuf->smbus_KernelVersion, smbus_KernelVersion, sizeof(pBuf->smbus_KernelVersion));
 pBuf->smbus_KernelVersion[sizeof(pBuf->smbus_KernelVersion) - 1] = '\0';
 return;
}
static noinline void* smbus_DMA_Memory_Alloc(unsigned int Size)
{
 void *pVirt = NULL;
 dma_addr_t dummy;
 if ((smbusArchXEN & 0x00000001) &&
  (smbusArchFacil & 0x00002000))
 {
  pVirt = (void *) SMBUS_DMA_MEM_GET(SMBUS_MY_DMA_DEVICE, 4*1024, &dummy, GFP_DMA);
  if (pVirt == NULL)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_DMA_alloc(): ## ERROR! dma_alloc_coherent failed (dev=0x%p, size=%d, dummy=0x%p, flags=0x%08X)!\n", (int)(jiffies-jiffies0), SMBUS_MY_DMA_DEVICE, 4*1024, &dummy, GFP_DMA); } while (0);
   return NULL;
  }
  else
  {
   return pVirt;
  }
 }
 else
 {
  pVirt = (void *) __get_free_page(GFP_KERNEL | GFP_DMA);
  if (pVirt == NULL)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_DMA_alloc(): ## ERROR! __get_free_page failed (0x%08X)!\n", (int)(jiffies-jiffies0), (GFP_KERNEL | GFP_DMA)); } while (0);
   return NULL;
  }
  else
  {
   mem_map_reserve(virt_to_page(pVirt));
   return pVirt;
  }
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_DMA_alloc(): ## ERROR! This should not happend (0x%08X)!\n", (int)(jiffies-jiffies0), 0xFFFFFFFF); } while (0);
 return NULL;
}
static noinline void smbus_DMA_Memory_Free(void *pVirt, unsigned int Size)
{
 if (pVirt != NULL)
 {
  if ((smbusArchXEN & 0x00000001) &&
   (smbusArchFacil & 0x00002000))
  {
   SMBUS_DMA_MEM_FREE(SMBUS_MY_DMA_DEVICE, 4*1024, pVirt, virt_to_bus(pVirt));
  }
  else
  {
   mem_map_unreserve(virt_to_page(pVirt));
   free_page((ulong)(pVirt));
  }
 }
}
static noinline void free_all(void)
{
 int i;
 if (m_pGabiSearchAddr != NULL) {
  iounmap((void *) m_pGabiSearchAddr);
  m_pGabiSearchAddr = NULL;
 }
 if (m_pVirtMemoryGABI != NULL) {
  vfree(m_pVirtMemoryGABI);
  m_pVirtMemoryGABI = NULL;
  m_fGabiExec = NULL;
 }
 FreeBuffer (&m_GabiControlBuffer);
 FreeBuffer (&m_GabiRequestBuffer);
 FreeBuffer (&m_GabiResponseBuffer);
 FreeBuffer (&m_pGABIStaticPage);
 if (m_pInOutBufferGABI != NULL)
 {
  kfree(m_pInOutBufferGABI);
  m_pInOutBufferGABI = NULL;
 }
 for (i = 0; i < 256; i++)
 {
  memset(OpenDevicesPersist[i], 0, sizeof(SMBUS_DEVICE_ADDRESS_DATA_ST));
  OpenDevices[i] = NULL;
 }
}
static struct file_operations smbus_fops =
{
 DRIVER_FOPS
};
noinline int init_module(void)
{
 int ret;
 int i;
 jiffies0 = jiffies;
 if ((ret = smbus_DetermineEnvironment()) < 0) {
  printk(KERN_ERR "smbus(%d): " "init_module: unable to determine OS/HW environment (return = %d)\n", (int)(jiffies-jiffies0), ret);
  return -ENODEV;
 }
 DetectBiosInterfaces();
 if (smbusDebug> 0)
 {
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsGabiHwFound    = %d\n", (int)(jiffies-jiffies0), IsGabiHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsSmbusHwFound   = %d --> postponed to later on\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsBusIoHwFound   = %d\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsCpuErrHwFound  = %d\n", (int)(jiffies-jiffies0), IsCpuErrHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsCpuApicHwFound = %d\n", (int)(jiffies-jiffies0), IsCpuApicHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsCpuInfoHwFound = %d\n", (int)(jiffies-jiffies0), IsCpuInfoHwFound); } while (0);
 }
 DRIVER_SET_OWNER;
 if((ret = register_chrdev(smbus_major, SMBUS_DEV, &smbus_fops)) < 0) {
  printk(KERN_ERR "smbus(%d): " "unable to get major %d  return = %d\n", (int)(jiffies-jiffies0), smbus_major, ret);
  free_all();
  return -EIO;
 }
 if (ret > 0) smbus_major = ret;
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "init_module: major device number = %d (0x%08x)\n", (int)(jiffies-jiffies0),smbus_major, smbus_major); } while (0);
 for (i=0; i<256; i++)
 {
  OpenDevicesPersist[i] = &(SmBus_DAD_Buff[i]);
 }
 smbus_FillCpuInfoTable();
 smbus_InitDriverInfo();
 return 0;
}
noinline void cleanup_module(void)
{
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "cleanup_module entered (%d)\n", (int)(jiffies-jiffies0),0); } while (0);
 free_all();
 (void) unregister_chrdev(smbus_major, SMBUS_DEV);
}
static noinline void DetectBiosInterfaces(void)
{
 IsGabiHwFound = FindGabi();
 return;
}
noinline long smbus_ioctl_compat(struct file *file, unsigned int cmd, unsigned long arg)
{
 long result;
 GET_BIG_DRIVER_LOCK;
#ifdef KERNEL30
 result = (long) smbus_ioctl_body(file, cmd, arg);
#else
 result = (long) smbus_ioctl_body(NULL, file, cmd, arg);
#endif
 FREE_BIG_DRIVER_LOCK;
 return result;
}
#ifdef KERNEL30
static noinline long smbus_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
{
 long result;
 GET_BIG_DRIVER_LOCK;
 result = (long) smbus_ioctl_body(file, cmd, arg);
 FREE_BIG_DRIVER_LOCK;
 return result;
}
#else
static noinline int smbus_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
{
 int result;
 result = (int) smbus_ioctl_body(NULL, file, cmd, arg);
 return result;
}
#endif
#ifdef KERNEL30
static noinline long smbus_ioctl_body(struct file *file, unsigned int cmd, unsigned long arg)
#else
static noinline int smbus_ioctl_body(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
#endif
{
 unsigned int ioc_number = 0;
 unsigned int ioc_magic = 0;
 unsigned int ioc_size = 0;
 int err = 0;
#ifdef KERNEL30
 struct inode *inode = NULL;
#ifdef KERNEL40
 if (file != NULL && file->f_path.dentry != NULL)
 {
  inode = file->f_path.dentry->d_inode;
 }
#else
 if (file != NULL && file->f_dentry != NULL)
 {
  inode = file->f_dentry->d_inode;
 }
#endif
#endif
 ioc_magic = (unsigned int)_IOC_TYPE(cmd);
 ioc_size = (unsigned int)_IOC_SIZE(cmd);
 ioc_number = (unsigned int)_IOC_NR(cmd);
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: (node=0x%p,file=0x%p) IOCTL=0x%08X (magic=0x%08X, number=0x%08X, size=0x%08X) arg=0x%016lX\n", (int)(jiffies-jiffies0),(void *)inode, (void *)file, cmd, ioc_magic, ioc_number, ioc_size, arg); } while (0);
 if (ioc_magic != 's') {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: CmdType != magic (0x%08X, 0x%08X) !!!\n", (int)(jiffies-jiffies0), ioc_magic, 's'); } while (0);
  return -EPERM;
 }
 if (ioc_number == (unsigned int)0xFF)
 {
  unsigned char *parg;
  IOCTLDATA_SMBUS_DRIVER_INFO *pInOutBuf;
  IOCTLDATA_SMBUS_DRIVER_INFO_HDR IoCtrlBufHdr;
  IOCTLDATA_SMBUS_DRIVER_INFO IoCtrlBuf;
  parg = (unsigned char *) (unsigned long) arg;
  if (parg == NULL) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
   return -EINVAL;
  }
  err = copy_from_user((unsigned char *)&IoCtrlBufHdr, parg, sizeof(IoCtrlBufHdr));
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (unsigned char *)parg); } while (0);
   return -EFAULT;
  }
  if (IoCtrlBufHdr.VersionOfThisIoctl != smbus_DriverInfoHdr.VersionOfThisIoctl)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: something is fishy on IOCTL_SMBUS_DRIVER_INFO: VersOfIoctl=%d, VerOfDriver=%d\n", (int)(jiffies-jiffies0), IoCtrlBufHdr.VersionOfThisIoctl, smbus_DriverInfoHdr.VersionOfThisIoctl); } while (0);
   return -EINVAL;
  }
  if (IoCtrlBufHdr.SizeOfInOutBuffer != smbus_DriverInfoHdr.SizeOfInOutBuffer)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: something is fishy on IOCTL_SMBUS_DRIVER_INFO: sizeIoctl=%d, sizeDriver=%d\n", (int)(jiffies-jiffies0), IoCtrlBufHdr.SizeOfInOutBuffer, smbus_DriverInfoHdr.SizeOfInOutBuffer); } while (0);
   return -EINVAL;
  }
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO is OK ! (node=0x%p,file=0x%p) IOCTL=0x%08X (magic=0x%08X, number=0x%08X, size=0x%08X) arg=0x%016lX\n", (int)(jiffies-jiffies0),(void *)inode, (void *)file, cmd, ioc_magic, ioc_number, ioc_size, arg); } while (0);
  smbus_DriverInfoHdr.pInOutBuffer = IoCtrlBufHdr.pInOutBuffer;
  pInOutBuf = (IOCTLDATA_SMBUS_DRIVER_INFO *)(unsigned long)(IoCtrlBufHdr.pInOutBuffer);
  if (pInOutBuf == NULL)
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: IOCTL_SMBUS_DRIVER_INFO: Illegal parameter pInOutBuf=0x%p\n", (int)(jiffies-jiffies0), pInOutBuf); } while (0);
   return -EINVAL;
  }
  err = copy_from_user((unsigned char*)&IoCtrlBuf, (unsigned char *)pInOutBuf, sizeof(IoCtrlBuf));
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: IOCTL_SMBUS_DRIVER_INFO copy_from_user failed err = 0x%08X, pInOutBuf = 0x%p\n", (int)(jiffies-jiffies0), err, pInOutBuf); } while (0);
   return -EFAULT;
  }
  strncpy(smbus_DriverInfo.RequestorName, IoCtrlBuf.RequestorName, sizeof(smbus_DriverInfo.RequestorName));
  smbus_DriverInfo.RequestorName[sizeof(smbus_DriverInfo.RequestorName) - 1] = '\0';
  smbus_DriverInfo.RequestorVersion = IoCtrlBuf.RequestorVersion;
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: RequestorName = \"%s\", RequestorVersion = 0x%08X\n", (int)(jiffies-jiffies0), smbus_DriverInfo.RequestorName, smbus_DriverInfo.RequestorVersion); } while (0);
  if (smbus_DriverInfo.RequestorVersion < smbus_DriverInfo.smbus_VersionCode)
  {
   printk(KERN_INFO "smbus(%d): " "smbus_ioctl: WARNING: IOCTL_SMBUS_DRIVER_INFO: Version Code (0x%08X) of Requestor \"%s\" is less than Version Code (0x%08X) of this driver\n", (int)(jiffies-jiffies0), smbus_DriverInfo.RequestorVersion, smbus_DriverInfo.RequestorName, smbus_DriverInfo.smbus_VersionCode);
  }
  strncpy(smbus_DriverInfo.SV_SYSTEM, IoCtrlBuf.SV_SYSTEM, sizeof(smbus_DriverInfo.SV_SYSTEM));
  smbus_DriverInfo.SV_SYSTEM[sizeof(smbus_DriverInfo.SV_SYSTEM) - 1] = '\0';
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: Requestor: SV_SYSTEM   = \"%s\"\n", (int)(jiffies-jiffies0), smbus_DriverInfo.SV_SYSTEM); } while (0);
  strncpy(smbus_DriverInfo.SV_OS, IoCtrlBuf.SV_OS, sizeof(smbus_DriverInfo.SV_OS));
  smbus_DriverInfo.SV_OS[sizeof(smbus_DriverInfo.SV_OS) - 1] = '\0';
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: Requestor: SV_OS       = \"%s\"\n", (int)(jiffies-jiffies0), smbus_DriverInfo.SV_OS); } while (0);
  strncpy(smbus_DriverInfo.SV_NICKNAME, IoCtrlBuf.SV_NICKNAME, sizeof(smbus_DriverInfo.SV_NICKNAME));
  smbus_DriverInfo.SV_NICKNAME[sizeof(smbus_DriverInfo.SV_NICKNAME) - 1] = '\0';
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: Requestor: SV_NICKNAME = \"%s\"\n", (int)(jiffies-jiffies0), smbus_DriverInfo.SV_NICKNAME); } while (0);
  err = copy_to_user((unsigned char *)pInOutBuf, (unsigned char *)&smbus_DriverInfo, IoCtrlBufHdr.SizeOfInOutBuffer);
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: copy_to_user failed err = 0x%08X, pInOutBuf = 0x%p\n", (int)(jiffies-jiffies0), err, (unsigned char *)pInOutBuf); } while (0);
   return -EFAULT;
  }
  smbus_DriverInfoHdr.Success = 1;
  err = copy_to_user(parg, (unsigned char *)&smbus_DriverInfoHdr, sizeof(IOCTLDATA_SMBUS_DRIVER_INFO_HDR));
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (unsigned char *)parg); } while (0);
   return -EFAULT;
  }
  return sizeof(IOCTLDATA_SMBUS_DRIVER_INFO);
 }
 if ((ioc_number < 0x55) || (ioc_number > 0x73)) {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: CmdNumber out of range (0x%08X [0x%08X 0x%08X]) !!! \n", (int)(jiffies-jiffies0), ioc_number, 0x55, 0x73); } while (0);
  return -EPERM;
 }
 switch(ioc_number)
 {
  case 0x66:
  {
   down(&smbus_mutex);
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "GABI: IOCTL_DEVBIOS_GABI_DETECTED %d\n", (int)(jiffies-jiffies0), IsGabiHwFound); } while (0);
   if (!IsGabiHwFound || (m_pGabiBase == NULL) || (m_fGabiExec == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: GABI not available ! (0x%p, 0x%p) \n", (int)(jiffies-jiffies0), m_pGabiBase, m_fGabiExec); } while (0);
    up(&smbus_mutex);
    return -ENXIO;
   }
   up(&smbus_mutex);
   return 0;
  }
  case 0x67:
  {
   unsigned char *parg = NULL;
   unsigned char *pInputBufferUser = NULL;
   unsigned char *pOutputBufferUser = NULL;
   unsigned char *pInputBuffer = NULL;
   unsigned char *pOutputBuffer = NULL;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   unsigned int inputSize = 0;
   unsigned int outputSize = 0;
   unsigned int nrBytesReturn = 0;
   down(&smbus_mutex);
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "GABI: IOCTL_DEVBIOS_GABI_EXEC_CMD %d\n", (int)(jiffies-jiffies0), IsGabiHwFound); } while (0);
   if (!IsGabiHwFound || (m_pGabiBase == NULL) || (m_fGabiExec == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: GABI not available ! (0x%p, 0x%p) \n", (int)(jiffies-jiffies0), m_pGabiBase, m_fGabiExec); } while (0);
    up(&smbus_mutex);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    up(&smbus_mutex);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   pInputBufferUser = (unsigned char *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutputBufferUser = (unsigned char *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   inputSize = IoCtrlBuf.InBufferSize;
   outputSize = IoCtrlBuf.OutBufferSize;
   pInputBuffer = m_pInOutBufferGABI;
   pOutputBuffer = m_pInOutBufferGABI + 6*1024;
   if (NULL == pInputBufferUser || NULL == pInputBufferUser ||
    inputSize == 0 || outputSize == 0 || inputSize > 6*1024 || outputSize > 6*1024)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR! Illegal parameters pInputBufferUser=0x%p, pOutputBufferUser=0x%p, inputSize=%d, outputSize=%d!\n", (int)(jiffies-jiffies0), pInputBufferUser, pOutputBufferUser, inputSize, outputSize); } while (0);
    up(&smbus_mutex);
    return -EINVAL;
   }
   err = copy_from_user(pInputBuffer, pInputBufferUser, inputSize);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_from_user failed err = 0x%08X, pInputBufferUser = 0x%p\n", (int)(jiffies-jiffies0), err, pInputBufferUser); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   if (!GabiExecuteCommand (pInputBuffer, inputSize, pOutputBuffer, outputSize, &nrBytesReturn))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: GabiExecuteCommand() failed ! parg=0x%p\n", (int)(jiffies-jiffies0), parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   if (nrBytesReturn > outputSize)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## WARNING: nrBytesReturn (%d) is greater than > outputSize (%d) --> truncated\n", (int)(jiffies-jiffies0), nrBytesReturn, outputSize); } while (0);
    nrBytesReturn = outputSize;
   }
   err = copy_to_user(pOutputBufferUser, pOutputBuffer, nrBytesReturn);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_from_user failed err = 0x%08X, pOutputBuffer = 0x%p, nrBytesReturn=%d\n", (int)(jiffies-jiffies0), err, pOutputBuffer, nrBytesReturn); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   IoCtrlBuf.ReturnedBytes = nrBytesReturn;
   IoCtrlBuf.Success = 1;
   err = copy_to_user(parg, (unsigned char *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   up(&smbus_mutex);
   return nrBytesReturn;
  }
  case 0x55:
  {
   unsigned char *parg;
   unsigned char *pInBuffer;
   unsigned char *pOutBuffer;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   IOCTLDATA_READ_SMBUS smbus;
   unsigned int InBufferSize;
   unsigned int OutBufferSize;
   unsigned char SBuffer[sizeof(unsigned int)];
   unsigned char * pBuffer = (unsigned char *)SBuffer;
   unsigned char * pBAlloc = NULL;
   unsigned int iLength;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pInBuffer = (unsigned char *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutBuffer = (unsigned char *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   InBufferSize = IoCtrlBuf.InBufferSize;
   OutBufferSize = IoCtrlBuf.OutBufferSize;
   if ((pInBuffer == NULL) || (pOutBuffer == NULL)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) pInBuffer=0x%p, pOutBuffer=0x%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
    return -EINVAL;
   }
   if ((InBufferSize < sizeof(IOCTLDATA_READ_SMBUS)) || (OutBufferSize == 0)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) InBufferSize=%d (min %d), OutBufferSize=%d\n", (int)(jiffies-jiffies0), InBufferSize, (unsigned int)sizeof(IOCTLDATA_READ_SMBUS), OutBufferSize); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&smbus, pInBuffer, sizeof(IOCTLDATA_READ_SMBUS));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pInBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pInBuffer); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMBUS dev 0x%08X off 0x%08X len %d\n", (int)(jiffies-jiffies0), smbus.DeviceAddress, smbus.StartOffset, OutBufferSize); } while (0);
   if ((smbus.DeviceAddress >= 0x100) || (smbus.StartOffset >= 0x100)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid DeviceAddress=%d or StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smbus.DeviceAddress, smbus.StartOffset); } while (0);
    return -EINVAL;
   }
   if (OutBufferSize > sizeof(SBuffer)) {
    pBAlloc = pBuffer = (unsigned char *)kmalloc(OutBufferSize, GFP_USER);
    if (!pBAlloc)
     return -EAGAIN;
   }
   iLength = smbus_ReadData((unsigned char)(smbus.DeviceAddress), (unsigned char)(smbus.StartOffset), pBuffer, OutBufferSize);
   if (iLength > OutBufferSize)
    iLength = OutBufferSize;
   if (iLength > 0) {
    err = copy_to_user(pOutBuffer, pBuffer, iLength);
    if (err != 0) {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, pOutBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pOutBuffer); } while (0);
     if (pBAlloc != NULL)
      kfree(pBAlloc);
     return -EFAULT;
    }
    IoCtrlBuf.ReturnedBytes = iLength;
    IoCtrlBuf.Success = (iLength == OutBufferSize);
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   err = copy_to_user(parg, (unsigned char *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   return iLength;
  }
  case 0x56:
  {
   unsigned char *parg;
   unsigned char *pData;
   IOCTLDATA_WRITE_SMBUS smbus;
   unsigned char SBuffer[sizeof(unsigned int)];
   unsigned char * pBuffer = (unsigned char *)SBuffer;
   unsigned char * pBAlloc = NULL;
   unsigned int iLength;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&smbus, parg, (sizeof (IOCTLDATA_WRITE_SMBUS) - 256));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pData = parg + (sizeof (IOCTLDATA_WRITE_SMBUS) - 256);
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMBUS dev 0x%08X off 0x%08X data 0x%p len %d\n", (int)(jiffies-jiffies0), smbus.DeviceAddress, smbus.StartOffset, pData, smbus.BytesToWrite); } while (0);
   if ((smbus.BytesToWrite == 0) || (smbus.BytesToWrite > 256)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: invalid BytesToWrite value !!! (%d) \n", (int)(jiffies-jiffies0), smbus.BytesToWrite); } while (0);
    return -EINVAL;
   }
   if (smbus.StartOffset >= 0x100) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smbus.StartOffset); } while (0);
    return -EINVAL;
   }
   if (smbus.BytesToWrite > sizeof SBuffer) {
    pBAlloc = pBuffer = (unsigned char *)kmalloc(smbus.BytesToWrite, GFP_USER);
    if (!pBAlloc)
     return -EAGAIN;
   }
   err = copy_from_user(pBuffer, pData, smbus.BytesToWrite);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pData = 0x%p\n", (int)(jiffies-jiffies0), err, pData); } while (0);
    if (pBAlloc)
     kfree(pBAlloc);
    return -EFAULT;
   }
   iLength = smbus_WriteData((unsigned char)(smbus.DeviceAddress), (unsigned char)(smbus.StartOffset), pBuffer, smbus.BytesToWrite);
   if ( iLength != smbus.BytesToWrite) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_WriteData() failed, only %d written\n", (int)(jiffies-jiffies0), iLength); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -ENXIO;
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   return smbus.BytesToWrite;
  }
  case 0x57:
  {
   unsigned char *parg;
   unsigned char *pInBuffer;
   unsigned char *pOutBuffer;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   SMBUS_DEVICE_ADDRESS_DATA_ST smdev;
   unsigned int InBufferSize;
   unsigned int OutBufferSize;
   unsigned int DeviceHandle;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pInBuffer = (unsigned char *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutBuffer = (unsigned char *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   InBufferSize = IoCtrlBuf.InBufferSize;
   OutBufferSize = IoCtrlBuf.OutBufferSize;
   if ((pInBuffer == NULL) || (pOutBuffer == NULL)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) pInBuffer=0x%p, pOutBuffer=0x%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
    return -EINVAL;
   }
   if ((InBufferSize < (sizeof(IOCTLDATA_SMBUS_OPEN_DEVICE))) ||
    (InBufferSize > sizeof(smdev)) || (OutBufferSize < sizeof(unsigned int)))
   {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) InBufferSize=%d (max %d), OutBufferSize=%d\n", (int)(jiffies-jiffies0), InBufferSize, (unsigned int)sizeof(smdev), OutBufferSize); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&smdev, pInBuffer, InBufferSize);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pInBuffer = 0x%p, InBufferSize = %d\n", (int)(jiffies-jiffies0), err, pInBuffer, InBufferSize); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV dev 0x%02x\n", (int)(jiffies-jiffies0), smdev.iod_open.DeviceAddress); } while (0);
   err = smbus_OpenDevice(&DeviceHandle, &smdev, InBufferSize);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_OpenDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    return -ENXIO;
   }
   err = copy_to_user(pOutBuffer, &DeviceHandle, sizeof(unsigned int));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, pOutBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pOutBuffer); } while (0);
    smbus_CloseDevice(DeviceHandle);
    return -EFAULT;
   }
   IoCtrlBuf.ReturnedBytes = sizeof(unsigned int);
   IoCtrlBuf.Success = 1;
   err = copy_to_user(parg, (unsigned char *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    smbus_CloseDevice(DeviceHandle);
    return -EFAULT;
   }
   return sizeof(unsigned int);
  }
  case 0x58:
  {
   unsigned int DeviceHandle;
   unsigned char *parg;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user(&DeviceHandle, (unsigned char *)parg, sizeof(unsigned int));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (unsigned char *)parg); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV handle %d \n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
   err = smbus_CloseDevice(DeviceHandle);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_ReadDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    return -ENXIO;
   }
   return 0;
  }
  case 0x59:
  {
   unsigned char *parg;
   unsigned char *pInBuffer;
   unsigned char *pOutBuffer;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   IOCTLDATA_SMBUS_READ_DEVICE smdev;
   unsigned int InBufferSize;
   unsigned int OutBufferSize;
   unsigned char SBuffer[sizeof(unsigned int)];
   unsigned char *pBuffer = SBuffer;
   unsigned char *pBAlloc = NULL;
   unsigned int iLength;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pInBuffer = (unsigned char *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutBuffer = (unsigned char *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   InBufferSize = IoCtrlBuf.InBufferSize;
   OutBufferSize = IoCtrlBuf.OutBufferSize;
   if ((pInBuffer == NULL) || (pOutBuffer == NULL)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) pInBuffer=0x%p, pOutBuffer=0x%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
    return -EINVAL;
   }
   if ((InBufferSize < sizeof(IOCTLDATA_SMBUS_READ_DEVICE)) || (OutBufferSize == 0)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) InBufferSize=%d (min %d), OutBufferSize=%d\n", (int)(jiffies-jiffies0), InBufferSize, (unsigned int)sizeof(IOCTLDATA_SMBUS_READ_DEVICE), OutBufferSize); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&smdev, pInBuffer, sizeof(IOCTLDATA_SMBUS_READ_DEVICE));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pInBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV handle %d off %d len %d\n", (int)(jiffies-jiffies0), smdev.DeviceHandle, smdev.StartOffset, OutBufferSize); } while (0);
   if (smdev.StartOffset >= 0x100) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smdev.StartOffset); } while (0);
    return -EINVAL;
   }
   if (OutBufferSize > sizeof SBuffer)
   {
    pBAlloc = pBuffer = (unsigned char *)kmalloc(OutBufferSize, GFP_USER);
    if (pBAlloc == NULL)
     return -EAGAIN;
   }
   err = smbus_ReadDevice(smdev.DeviceHandle, (unsigned char)smdev.StartOffset, OutBufferSize, pBuffer, &iLength);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_ReadDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -ENXIO;
   }
   if (iLength > OutBufferSize)
    iLength = OutBufferSize;
   if (iLength > 0) {
    err = copy_to_user(pOutBuffer, pBuffer, iLength);
    if (err != 0) {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, pOutBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pOutBuffer); } while (0);
     if (pBAlloc != NULL)
      kfree(pBAlloc);
     return -EFAULT;
    }
    IoCtrlBuf.ReturnedBytes = iLength;
    IoCtrlBuf.Success = 1;
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   err = copy_to_user(parg, (unsigned char *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   return iLength;
  }
  case 0x5A:
  {
   IOCTLDATA_SMBUS_WRITE_DEVICE smdev;
   unsigned char *parg;
   unsigned char SBuffer[sizeof(unsigned int)];
   unsigned char *pBuffer = SBuffer;
   unsigned char *pBAlloc = NULL;
   unsigned char *pProcessData;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&smdev, parg, (sizeof (IOCTLDATA_SMBUS_WRITE_DEVICE) - sizeof (uint8_t)));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (unsigned char *)parg); } while (0);
    return -EFAULT;
   }
   pProcessData = parg + (sizeof (IOCTLDATA_SMBUS_WRITE_DEVICE) - sizeof (uint8_t));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "SMDEV handle %d off %d data 0x%p len %d\n", (int)(jiffies-jiffies0), smdev.DeviceHandle, smdev.StartOffset, pProcessData, smdev.BytesToWrite); } while (0);
   if ((smdev.BytesToWrite == 0) || (smdev.BytesToWrite > 256)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: invalid BytesToWrite value !!! (%d) \n", (int)(jiffies-jiffies0), smdev.BytesToWrite); } while (0);
    return -EINVAL;
   }
   if (smdev.StartOffset >= 0x100) {
    do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smdev.StartOffset); } while (0);
    return -EINVAL;
   }
   if (smdev.BytesToWrite > sizeof(SBuffer)) {
    pBAlloc = pBuffer = (unsigned char *) kmalloc(smdev.BytesToWrite, GFP_USER);
    if (pBAlloc == NULL)
     return -EAGAIN;
   }
   err = copy_from_user(pBuffer, pProcessData, smdev.BytesToWrite);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pProcessData = 0x%p\n", (int)(jiffies-jiffies0), err, pProcessData); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -EFAULT;
   }
   err = smbus_WriteDevice(smdev.DeviceHandle, (unsigned char)smdev.StartOffset, smdev.BytesToWrite, pBuffer);
   if ( err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_WriteDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -ENXIO;
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   return smdev.BytesToWrite;
  }
  case 0x6C:
  {
   IOCTLDATA_INDEXED_PORT_IO portio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&portio, (IOCTLDATA_INDEXED_PORT_IO *)arg, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "PORTIO index 0x%02x=0x%02x data 0x%02x\n", (int)(jiffies-jiffies0), portio.IndexPort, portio.IndexData, portio.DataPort); } while (0);
   ReadFromIndexedPort(&portio);
   err = copy_to_user((IOCTLDATA_INDEXED_PORT_IO *)arg, &portio, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   return sizeof(IOCTLDATA_INDEXED_PORT_IO);
  }
  case 0x6B:
  {
   IOCTLDATA_INDEXED_PORT_IO portio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&portio, (IOCTLDATA_INDEXED_PORT_IO *)arg, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "PORTIO index 0x%02x=0x%02x data 0x%02x=0x%02x\n", (int)(jiffies-jiffies0), portio.IndexPort, portio.IndexData, portio.DataPort, portio.DataData); } while (0);
   WriteToIndexedPort(&portio);
   err = copy_to_user((IOCTLDATA_INDEXED_PORT_IO *)arg, &portio, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   return sizeof (IOCTLDATA_INDEXED_PORT_IO);
  }
  case 0x6D:
  {
   IOCTLDATA_GEN_IO genio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&genio, (IOCTLDATA_GEN_IO *)arg, sizeof(IOCTLDATA_GEN_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "GENIO-1 [%d] of 0x%08x\n", (int)(jiffies-jiffies0), genio.DataWidth, genio.Address); } while (0);
   if (genio.Address >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
   genio.WriteData = 0L;
   switch(genio.DataWidth)
   {
    case sizeof(unsigned char):
     genio.WriteData = (unsigned int)inb((unsigned short)genio.Address);
     break;
    case sizeof(unsigned short):
     genio.WriteData = (unsigned int)inw((unsigned short)genio.Address);
     break;
    case sizeof(unsigned int):
     genio.WriteData = (unsigned int)inl((unsigned short)genio.Address);
     break;
    default:
     return -EINVAL;
   }
   err = copy_to_user((unsigned char *)arg, &genio.WriteData, genio.DataWidth);
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "GENIO-2 [%d]0x%08x from 0x%08x\n", (int)(jiffies-jiffies0), genio.DataWidth, genio.WriteData, genio.Address); } while (0);
   return genio.DataWidth;
  }
  case 0x6E:
  {
   IOCTLDATA_GEN_IO genio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&genio, (IOCTLDATA_GEN_IO *)arg, sizeof(IOCTLDATA_GEN_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "GENIO-3 [%d] 0x%08x to 0x%08x\n", (int)(jiffies-jiffies0), genio.DataWidth, genio.WriteData, genio.Address); } while (0);
   if (genio.Address >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
   switch(genio.DataWidth)
   {
    case sizeof(unsigned char):
     if (genio.WriteData >= (1 << (sizeof(unsigned char) * 8))) return -EINVAL;
     outb((unsigned char)genio.WriteData, (unsigned short)genio.Address);
     break;
    case sizeof(unsigned short):
     if (genio.WriteData >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
     outw((unsigned short)genio.WriteData, (unsigned short)genio.Address);
     break;
    case sizeof(unsigned int):
     outl((unsigned int)genio.WriteData, (unsigned short)genio.Address);
     break;
    default:
     return -EINVAL;
   }
   err = copy_to_user((IOCTLDATA_GEN_IO *)arg, &genio, sizeof(IOCTLDATA_GEN_IO));
   return genio.DataWidth;
  }
  case 0x6F:
  {
   unsigned char *parg;
   IOCTLDATA_MULTIPORT_IO_ELEM *pElement = NULL;
   unsigned char *pOutBuffer = NULL;
   unsigned int NrElements;
   unsigned int SizeOfOutBuffer;
   unsigned int i;
   int IsOutBufferAllocated = 0;
   IOCTLDATA_MULTIPORT_IO mpioHdr;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   parg = (unsigned char *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((unsigned char *)&mpioHdr, parg, sizeof(IOCTLDATA_MULTIPORT_IO));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   NrElements = mpioHdr.NumberElements;
   if (NrElements == 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: It is nothing to do !!! (NrElements=%d)\n", (int)(jiffies-jiffies0), NrElements); } while (0);
    return -EINVAL;
   }
   if (NrElements == 1)
   {
    SizeOfOutBuffer = sizeof(IOCTLDATA_MULTIPORT_IO);
    pOutBuffer = (unsigned char *) &mpioHdr;
    IsOutBufferAllocated = 0;
    pElement = &(mpioHdr.Element[0]);
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MULTI_PORT_IO-Ioctl, NrElements=%d (SizeOfOutBuffer=%d)\n", (int)(jiffies-jiffies0), NrElements, SizeOfOutBuffer); } while (0);
   }
   else
   {
    SizeOfOutBuffer = ((size_t) &((IOCTLDATA_MULTIPORT_IO *)0)->Element) + (NrElements*sizeof(IOCTLDATA_MULTIPORT_IO_ELEM));
    pOutBuffer = kmalloc(SizeOfOutBuffer, GFP_USER);
    if (pOutBuffer == NULL)
     return -EAGAIN;
    IsOutBufferAllocated = 1;
    pElement = &((IOCTLDATA_MULTIPORT_IO *)pOutBuffer)->Element[0];
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MULTI_PORT_IO-Ioctl, NrElements=%d (SizeOfOutBuffer=%d)\n", (int)(jiffies-jiffies0), NrElements, SizeOfOutBuffer); } while (0);
    err = copy_from_user(pOutBuffer, parg, SizeOfOutBuffer);
    if (err != 0)
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err=0x%08X, parg=0x%p, pOutBuffer=0x%p, size=%d\n", (int)(jiffies-jiffies0), err, parg, pOutBuffer, SizeOfOutBuffer); } while (0);
     if (IsOutBufferAllocated)
     {
      kfree(pOutBuffer);
      IsOutBufferAllocated = 0;
     }
     return -EFAULT;
    }
   }
   for (i=0; i < NrElements; i++)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], Mode=0x%08X, Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Mode, pElement->Address, pElement->Data); } while (0);
    switch (pElement->Mode)
    {
     case 0x01:
      pElement->Data = (unsigned int) inb((unsigned short)pElement->Address);
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], InByte from Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      break;
     case 0x02:
      pElement->Data = (unsigned int) inw((unsigned short)pElement->Address);
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], InWord from Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      break;
     case 0x03:
      pElement->Data = (unsigned int) inl((unsigned short)pElement->Address);
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], InDWord from Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      break;
     case 0x09:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], OutByte to Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      outb((unsigned char)pElement->Data, (unsigned short)pElement->Address);
      break;
     case 0x0a:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], OutWord to Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      outw((unsigned short)pElement->Data, (unsigned short)pElement->Address);
      break;
     case 0x0b:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], OutDWord to Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      outl((unsigned int)pElement->Data, (unsigned short)pElement->Address);
      break;
     default:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d] ## ERROR in DeviceIoControl(): IOCTL_DEVBUSIO_MULTI_PORT_IO illegal Mode=0x%08X - fix this!\n", (int)(jiffies-jiffies0), i, pElement->Mode); } while (0);
      if (IsOutBufferAllocated)
      {
       kfree(pOutBuffer);
       IsOutBufferAllocated = 0;
      }
      return -EINVAL;
    }
    pElement++;
   }
   err = copy_to_user(parg, pOutBuffer, SizeOfOutBuffer);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err=0x%08X, parg=0x%p, pOutBuffer=0x%p, size=%d\n", (int)(jiffies-jiffies0), err, parg, pOutBuffer, SizeOfOutBuffer); } while (0);
    if (IsOutBufferAllocated)
    {
     kfree(pOutBuffer);
     IsOutBufferAllocated = 0;
    }
    return -EFAULT;
   }
   if (IsOutBufferAllocated)
   {
    kfree(pOutBuffer);
    IsOutBufferAllocated = 0;
   }
   return SizeOfOutBuffer;
  }
  case 0x5B:
  {
   IOCTLDATA_SMBUS_CHIP Chip;
   err = copy_from_user(&Chip, (IOCTLDATA_SMBUS_CHIP *)arg, sizeof(IOCTLDATA_SMBUS_CHIP));
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "DEVSMBUS_SET_CHIP received (len = %d)\n", (int)(jiffies-jiffies0), (int)sizeof(IOCTLDATA_SMBUS_CHIP)); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "Chip: BaseAddress  : 0x%08X\n", (int)(jiffies-jiffies0), Chip.BaseAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      VendorId     : 0x%04X\n", (int)(jiffies-jiffies0), Chip.VendorId); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      DeviceId     : 0x%04X\n", (int)(jiffies-jiffies0), Chip.DeviceId); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      Chipset      : 0x%02X\n", (int)(jiffies-jiffies0), Chip.Chipset); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      BusNo        : 0x%02X\n", (int)(jiffies-jiffies0), Chip.BusNo); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      DeviceNo     : 0x%02X\n", (int)(jiffies-jiffies0), Chip.DeviceNo); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      FunctionNo   : 0x%02X\n", (int)(jiffies-jiffies0), Chip.FunctionNo); } while (0);
   }
   my_SMBusBaseAddress = Chip.BaseAddress & 0x0000FFFC;
   my_VendorId = Chip.VendorId;
   my_DeviceId = Chip.DeviceId;
   my_Chipset = Chip.Chipset;
   my_BusNo = Chip.BusNo;
   my_DeviceNo = Chip.DeviceNo;
   my_FunctionNo = Chip.FunctionNo;
   if (my_Chipset == CS_UNKNOWN)
   {
    IsSmbusHwFound = 0;
   }
   else
   {
    IsSmbusHwFound = 1;
   }
   return 0;
  }
  case 0x70:
  {
   int cpunr;
   CpuInfo *pentry;
   CpuErrorInfo CpuErrInfo;
   CpuErrorInfo *pCpuErrInfo = &CpuErrInfo;
   IOCTLDATA_CORR_CPU_ERROR CpuError;
   if (!IsCpuErrHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_ERROR not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&CpuError, (IOCTLDATA_CORR_CPU_ERROR *)arg, sizeof(IOCTLDATA_CORR_CPU_ERROR));
   cpunr = CpuError.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_ERROR for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting cpu errors) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   if (pentry->MachineCheckArchitectureSupported)
   {
    memset (&CpuError, 0, sizeof(IOCTLDATA_CORR_CPU_ERROR));
    CpuError.ErrorType = CPUERR_TYPE_NO_ERROR;
    pCpuErrInfo->pCpuError = &CpuError;
    pCpuErrInfo->DenseCpuNr = cpunr;
    smbus_do_GetCpuError(pCpuErrInfo);
    CpuError.LogicalCpuNumber = cpunr;
    err = copy_to_user((IOCTLDATA_CORR_CPU_ERROR *)arg, &CpuError, sizeof(IOCTLDATA_CORR_CPU_ERROR));
    return sizeof(IOCTLDATA_CORR_CPU_ERROR);
   } else {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: Machine Check Architecure not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
  }
  case 0x71:
  {
   int cpunr;
   CpuInfo *pentry;
   IOCTLDATA_CPU_APICID_BOOT_CPU ApicInfo;
   if (!IsCpuApicHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&ApicInfo, (IOCTLDATA_CPU_APICID_BOOT_CPU *)arg, sizeof(IOCTLDATA_CPU_APICID_BOOT_CPU));
   cpunr = ApicInfo.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024) || (cpunr >= 256))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting local ApicId) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d (but max. 255)\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   if (pentry->LocalApicSupported) {
    if (pentry->MachineCheckArchitectureSupported) {
     if (pentry->ApicGlobalEnable) {
      if (pentry->ApicIdValid) {
       ApicInfo.LocalApicId = (unsigned char)pentry->ApicId;
       ApicInfo.IsBootCpu = pentry->BootstrapCpu ? 1 : 0;
       err = copy_to_user((IOCTLDATA_CPU_APICID_BOOT_CPU *)arg, &ApicInfo, sizeof(IOCTLDATA_CPU_APICID_BOOT_CPU));
      } else {
       do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: APIC Id for CPU %d not available\n", (int)(jiffies-jiffies0), cpunr); } while (0);
       return -ENXIO;
      }
     } else {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not enabled!\n", (int)(jiffies-jiffies0)); } while (0);
      return -ENXIO;
     }
    } else {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Machine Check Architecture (MCA) not supported!\n", (int)(jiffies-jiffies0)); } while (0);
     return -ENXIO;
    }
   } else {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   return sizeof(IOCTLDATA_CPU_APICID_BOOT_CPU);
  }
  case 0x72:
  {
   int cpunr;
   CpuInfo *pentry;
   IOCTLDATA_CPU_INFO LocalData;
   if (!IsCpuInfoHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_INFO not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&LocalData, (IOCTLDATA_CPU_INFO *)arg, sizeof(IOCTLDATA_CPU_INFO));
   cpunr = LocalData.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_INFO for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting CPU Info) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   LocalData.DenseCpuNr = pentry->DenseCpuNr;
   LocalData.SparseCpuNr = pentry->SparseCpuNr;
   LocalData.regs1Valid = pentry->regs1Valid;
   LocalData.regs2Valid = pentry->regs2Valid;
   LocalData.regs3Valid = pentry->regs3Valid;
   LocalData.regs4Valid = pentry->regs4Valid;
   LocalData.BrandStringValid = pentry->BrandStringValid;
   LocalData.NrCoresAMDValid = pentry->NrCoresAMDValid;
   LocalData.MachineCheckArchitectureSupported = pentry->MachineCheckArchitectureSupported;
   LocalData.LocalApicSupported = pentry->LocalApicSupported;
   LocalData.PrimaryLogicalCpu = pentry->PrimaryLogicalCpu;
   LocalData.LocalApicIdInitial = pentry->LocalApicIdInitial;
   LocalData.Vendor = pentry->Vendor;
   LocalData.NrCores = pentry->NrCores;
   LocalData.NumberLogicalCpus = pentry->NumberLogicalCpus;
   LocalData.regs0.eax = pentry->regs0.eax;
   LocalData.regs0.ebx = pentry->regs0.ebx;
   LocalData.regs0.ecx = pentry->regs0.ecx;
   LocalData.regs0.edx = pentry->regs0.edx;
   LocalData.regs1.eax = pentry->regs1.eax;
   LocalData.regs1.ebx = pentry->regs1.ebx;
   LocalData.regs1.ecx = pentry->regs1.ecx;
   LocalData.regs1.edx = pentry->regs1.edx;
   LocalData.regs2.eax = pentry->regs2.eax;
   LocalData.regs2.ebx = pentry->regs2.ebx;
   LocalData.regs2.ecx = pentry->regs2.ecx;
   LocalData.regs2.edx = pentry->regs2.edx;
   LocalData.regs3.eax = pentry->regs3.eax;
   LocalData.regs3.ebx = pentry->regs3.ebx;
   LocalData.regs3.ecx = pentry->regs3.ecx;
   LocalData.regs3.edx = pentry->regs3.edx;
   LocalData.regs4.eax = pentry->regs4.eax;
   LocalData.regs4.ebx = pentry->regs4.ebx;
   LocalData.regs4.ecx = pentry->regs4.ecx;
   LocalData.regs4.edx = pentry->regs4.edx;
   LocalData.MaxExtentions.eax = pentry->MaxExtentions.eax;
   LocalData.MaxExtentions.ebx = pentry->MaxExtentions.ebx;
   LocalData.MaxExtentions.ecx = pentry->MaxExtentions.ecx;
   LocalData.MaxExtentions.edx = pentry->MaxExtentions.edx;
   LocalData.BrandString1.eax = pentry->BrandString1.eax;
   LocalData.BrandString1.ebx = pentry->BrandString1.ebx;
   LocalData.BrandString1.ecx = pentry->BrandString1.ecx;
   LocalData.BrandString1.edx = pentry->BrandString1.edx;
   LocalData.BrandString2.eax = pentry->BrandString2.eax;
   LocalData.BrandString2.ebx = pentry->BrandString2.ebx;
   LocalData.BrandString2.ecx = pentry->BrandString2.ecx;
   LocalData.BrandString2.edx = pentry->BrandString2.edx;
   LocalData.BrandString3.eax = pentry->BrandString3.eax;
   LocalData.BrandString3.ebx = pentry->BrandString3.ebx;
   LocalData.BrandString3.ecx = pentry->BrandString3.ecx;
   LocalData.BrandString3.edx = pentry->BrandString3.edx;
   LocalData.NrCoresAMD.eax = pentry->NrCoresAMD.eax;
   LocalData.NrCoresAMD.ebx = pentry->NrCoresAMD.ebx;
   LocalData.NrCoresAMD.ecx = pentry->NrCoresAMD.ecx;
   LocalData.NrCoresAMD.edx = pentry->NrCoresAMD.edx;
   LocalData.BootstrapCpu = pentry->BootstrapCpu;
   LocalData.ApicGlobalEnable = pentry->ApicGlobalEnable;
   LocalData.x2ApicMode = pentry->x2ApicMode;
   LocalData.ApicIdValid = pentry->ApicIdValid;
   LocalData.ApicId = pentry->ApicId;
   LocalData.ApicBaseMsr = pentry->ApicBaseMsr;
   LocalData.ApicBaseAddress = pentry->ApicBaseAddress;
   LocalData.x2ApicLocalApicId = pentry->x2ApicLocalApicId;
   err = copy_to_user((IOCTLDATA_CPU_INFO *)arg, &LocalData, sizeof(IOCTLDATA_CPU_INFO));
   return sizeof(IOCTLDATA_CPU_INFO);
  }
  case 0x73:
  {
   int cpunr;
   CpuInfo *pentry;
   IOCTLDATA_CPU_APICID_EX ApicInfoEx;
   if (!IsCpuApicHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID_EX not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&ApicInfoEx, (IOCTLDATA_CPU_APICID_EX *)arg, sizeof(IOCTLDATA_CPU_APICID_EX));
   cpunr = ApicInfoEx.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID_EX for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting local ApicId) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   if (pentry->LocalApicSupported) {
    if (pentry->MachineCheckArchitectureSupported) {
     if (pentry->ApicGlobalEnable) {
      if (pentry->ApicIdValid) {
       memset (&ApicInfoEx, 0, sizeof (IOCTLDATA_CPU_APICID_EX));
       ApicInfoEx.LogicalCpuNumber = cpunr;
       ApicInfoEx.LocalApicId = pentry->ApicId;
       ApicInfoEx.IsBootCpu = pentry->BootstrapCpu ? 1 : 0;
       ApicInfoEx.xApicGlobalEnable = pentry->ApicGlobalEnable ? 1 : 0;
       ApicInfoEx.x2ApicMode = pentry->x2ApicMode ? 1 : 0;
       err = copy_to_user((IOCTLDATA_CPU_APICID_EX *)arg, &ApicInfoEx, sizeof(IOCTLDATA_CPU_APICID_EX));
      } else {
       do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: APIC Id for CPU %d not available (EX)\n", (int)(jiffies-jiffies0), cpunr); } while (0);
       return -ENXIO;
      }
     } else {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not enabled! (EX)\n", (int)(jiffies-jiffies0)); } while (0);
      return -ENXIO;
     }
    } else {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Machine Check Architecture (MCA) not supported! (EX)\n", (int)(jiffies-jiffies0)); } while (0);
     return -ENXIO;
    }
   } else {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not supported! (EX)\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   return sizeof(IOCTLDATA_CPU_APICID_EX);
  }
  default:
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: unsupported ioctl nr %d, size %d\n", (int)(jiffies-jiffies0), _IOC_NR(cmd), _IOC_SIZE(cmd)); } while (0);
   return -EPERM;
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: unsupported ioctl nr %d, size %d (should not be reached!)\n", (int)(jiffies-jiffies0), _IOC_NR(cmd), _IOC_SIZE(cmd)); } while (0);
 return -EPERM;
}
static noinline unsigned char * FindSignature (unsigned char * pStartAddress, unsigned int Size, unsigned char * pSignature, unsigned int SignatureSize, unsigned char ScanBoundary)
{
 unsigned int * findPtr;
 int b_signatureFound = 0;
 unsigned int index;
 unsigned int SignatureDWord = *((unsigned int *)pSignature);
 for ( index = 0; index <= Size; index += ScanBoundary)
 {
  findPtr = (unsigned int *) (pStartAddress + index);
  if ( *findPtr == SignatureDWord )
  {
   if(memcmp(findPtr, pSignature, SignatureSize) == 0)
   {
    b_signatureFound = 1;
    break;
   }
  }
 }
 if(!b_signatureFound)
 {
  return NULL;
 }
 return (void *)findPtr;
}
static noinline int AllocateBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, unsigned int bufferSize)
{
 bufferDescr->AllocatedSize = 0;
 bufferDescr->pVirtualAddress = NULL;
 bufferDescr->PhysicalAddress = 0;
 if (bufferSize > 4*1024)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR: cannot get memory greater than %d bytes (requested = %d)!\n", (int)(jiffies-jiffies0), 4*1024, bufferSize); } while (0);
  return 0;
 }
 bufferDescr->pVirtualAddress = (unsigned char *) smbus_DMA_Memory_Alloc(4*1024);
 if (bufferDescr->pVirtualAddress == NULL)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR! GABI static buffer allocation failed (requested=%d)!\n", (int)(jiffies-jiffies0), bufferSize); } while (0);
  return 0;
 }
 bufferDescr->AllocatedSize = bufferSize;
 if ((smbusArchXEN & 0x00000001) &&
  (smbusArchFacil & 0x00002000))
 {
  bufferDescr->PhysicalAddress = VIRT_TO_MACHINE(bufferDescr->pVirtualAddress);
 }
 else
 {
  bufferDescr->PhysicalAddress = virt_to_phys(bufferDescr->pVirtualAddress);
 }
 if (bufferDescr->PhysicalAddress > (unsigned long)(0xFFFFFFFF - 0xFFFF))
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR: BIOS cannot handle addresses above 4GB! (0x%016llX)\n", (int)(jiffies-jiffies0), bufferDescr->PhysicalAddress); } while (0);
  FreeBuffer(bufferDescr);
  return 0;
 }
 return 1;
}
static noinline void FreeBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr)
{
 if (bufferDescr->pVirtualAddress != NULL)
 {
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "FreeBuffer(): free buffer at virtual address = 0x%p\n", (int)(jiffies-jiffies0), bufferDescr->pVirtualAddress); } while (0);
  smbus_DMA_Memory_Free(bufferDescr->pVirtualAddress, 4*1024);
  bufferDescr->AllocatedSize = 0;
  bufferDescr->pVirtualAddress = NULL;
  bufferDescr->PhysicalAddress = 0;
 }
}
static noinline int FindGabi()
{
 int i;
 unsigned char *pBiosMappedAddress = NULL;
 ulong high_mem_phy;
 int Success = 0;
 unsigned long tmp_fGabiPage = 0;
 unsigned long tmp_fGabiOffset = 0;
 high_mem_phy = (ulong)virt_to_phys(high_memory);
 m_pGabiSearchAddr = ioremap(0xE0000, 0x20000);
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "FindGabi: high_mem_phy = 0x%016lX, m_pGabiSearchAddr = 0x%p\n", (int)(jiffies-jiffies0), high_mem_phy, m_pGabiSearchAddr); } while (0);
 if (m_pGabiSearchAddr == NULL)
 {
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "FindGabi: cannot map (by ioremap) GABI_BIOS_START_ADDRESS = 0x%016X (GABI_BIOS_SIZE = 0x%016X)\n", (int)(jiffies-jiffies0), 0xE0000, 0x20000); } while (0);
  m_pGabiBase = NULL;
  return 0;
 }
 pBiosMappedAddress = m_pGabiSearchAddr;
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABISearchAddress = 0x%p (0x%016X) [+0x%016X,0x%016X]\n", (int)(jiffies-jiffies0), pBiosMappedAddress, 0xE0000, 0, 0x20000); } while (0);
 if (pBiosMappedAddress != NULL)
 {
  unsigned char * pVirtualGabiStartAddr = pBiosMappedAddress;
  m_pGabiBase = (GABI_ENTRY_POINT *)FindSignature (pVirtualGabiStartAddr, (0x20000 - (((size_t) &((GABI_ENTRY_POINT *)0)->VendorSpecific))), (unsigned char *)"_GABIEP_", sizeof("_GABIEP_")-1, 16);
  if (m_pGabiBase != NULL)
  {
   unsigned char Checksum = 0;
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABIHeader     = 0x%p (0x%016lx)\n", (int)(jiffies-jiffies0), m_pGabiBase, (unsigned long)((unsigned char *)m_pGabiBase - pBiosMappedAddress + 0xE0000)); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderLength   = 0x%02X\n", (int)(jiffies-jiffies0), m_pGabiBase->ucLength); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderCheckSum = 0x%02X\n", (int)(jiffies-jiffies0), m_pGabiBase->ucCheckSum); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderVersion  = 0x%02X\n", (int)(jiffies-jiffies0), m_pGabiBase->ucVersion); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_16_Offset = 0x%04X\n", (int)(jiffies-jiffies0), m_pGabiBase->usApi16Ofs); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_16_Base   = 0x%08X\n", (int)(jiffies-jiffies0), m_pGabiBase->ulApi16Seg); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "EntryPoint32   = 0x%08X\n", (int)(jiffies-jiffies0), m_pGabiBase->ulEntryPoint32); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "EntryPoint64   = 0x%016llX\n", (int)(jiffies-jiffies0), m_pGabiBase->paEntryPoint64); } while (0);
   }
   for (i = 0; i < m_pGabiBase->ucLength; i++)
   {
    Checksum += ((unsigned char *)m_pGabiBase)[i];
   }
   if (Checksum != 0)
   {
    m_pGabiBase = NULL;
    if (m_pGabiSearchAddr != NULL)
    {
     iounmap((void *) m_pGabiSearchAddr);
     m_pGabiSearchAddr = NULL;
    }
    printk(KERN_NOTICE "smbus(%d): " "WARNING: GABI HeaderChecksum ERROR, chksum = 0x%02X\n", (int)(jiffies-jiffies0), Checksum);
    return 0;
   }
   m_fGabiExec = (GABI_CMD_ROUTINE) (pBiosMappedAddress + m_pGabiBase->paEntryPoint64 - 0xE0000);
   if (m_fGabiExec == NULL)
   {
    m_pGabiBase = NULL;
    if (m_pGabiSearchAddr != NULL)
    {
     iounmap((void *) m_pGabiSearchAddr);
     m_pGabiSearchAddr = NULL;
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "WARNING: GABI Service NOT available (1)!\n", (int)(jiffies-jiffies0)); } while (0);
    return 0;
   }
   if (smbusDebug> 0)
   {
    tmp_fGabiPage = (unsigned long) m_fGabiExec & ~0x0FFFUL;
    DumpBytes (5, "1. GabiPage (ori):\n", (unsigned char *)tmp_fGabiPage, 0x100);
    DumpBytes (5, "m_fGabiExec (ori):\n", (unsigned char *)m_fGabiExec, 0x200);
    tmp_fGabiPage = tmp_fGabiPage + 4*1024;
    DumpBytes (5, "2. GabiPage (ori):\n", (unsigned char *)tmp_fGabiPage, 0x100);
   }
   if (smbusArchMode & 0x02000000)
   {
    tmp_fGabiPage = (unsigned long) m_fGabiExec & ~0x0FFFUL;
    tmp_fGabiOffset = (unsigned long) m_fGabiExec & 0x0FFFUL;
    if ((m_pVirtMemoryGABI = VMALLOC_EXEC(2*4*1024)) != NULL)
    {
     memcpy(m_pVirtMemoryGABI, (void *) tmp_fGabiPage, 2*4*1024);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_fGabiExec (ori)    = 0x%p\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_pVirtMemoryGABI    = 0x%p\n", (int)(jiffies-jiffies0), m_pVirtMemoryGABI); } while (0);
     m_fGabiExec = m_pVirtMemoryGABI + tmp_fGabiOffset;
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_fGabiExec (new)    = 0x%p\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
     if (smbusDebug> 0)
     {
      tmp_fGabiPage = (unsigned long) m_fGabiExec & ~0x0FFFUL;
      DumpBytes (5, "1. GabiPage (new):\n", (unsigned char *)tmp_fGabiPage, 0x100);
      DumpBytes (5, "m_fGabiExec (new):\n", (unsigned char *)m_fGabiExec, 0x200);
      tmp_fGabiPage = tmp_fGabiPage + 4*1024;
      DumpBytes (5, "2. GabiPage (new):\n", (unsigned char *)tmp_fGabiPage, 0x100);
     }
     if (m_pGabiSearchAddr != NULL)
     {
      iounmap((void *) m_pGabiSearchAddr);
      m_pGabiSearchAddr = NULL;
     }
    }
    else
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "WARNING: Cannot get Executable-Page -> GABI Service NOT available!\n", (int)(jiffies-jiffies0)); } while (0);
     m_pGabiBase = NULL;
     m_fGabiExec = NULL;
     if (m_pGabiSearchAddr != NULL)
     {
      iounmap((void *) m_pGabiSearchAddr);
      m_pGabiSearchAddr = NULL;
     }
     return 0;
    }
   }
   Success = AllocateBuffer (&m_GabiControlBuffer, 1024);
   if (Success)
   {
    Success = AllocateBuffer (&m_GabiRequestBuffer, 4096);
    if (Success)
    {
     Success = AllocateBuffer (&m_GabiResponseBuffer, 4096);
     if (Success)
     {
      Success = AllocateBuffer (&m_pGABIStaticPage, 4*1024);
      if (Success)
      {
       m_pFreeVirtStMemGABI = m_pGABIStaticPage.pVirtualAddress;
       m_pFreePhysStMemGABI = m_pGABIStaticPage.PhysicalAddress;
       m_FreeStMemGABI = 4*1024;
       m_pInOutBufferGABI = (unsigned char *) kmalloc(2 * 6*1024, GFP_USER);
       if (m_pInOutBufferGABI == NULL)
       {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR: cannot get memory for In/Out-Buffer! (size=%d)\n", (int)(jiffies-jiffies0), 6*1024); } while (0);
        Success = 0;
       }
      }
     }
    }
   }
   if (!Success)
   {
    FreeBuffer (&m_GabiControlBuffer);
    FreeBuffer (&m_GabiRequestBuffer);
    FreeBuffer (&m_GabiResponseBuffer);
    FreeBuffer (&m_pGABIStaticPage);
    m_pGabiBase = NULL;
    if (m_pGabiSearchAddr != NULL)
    {
     iounmap((void *) m_pGabiSearchAddr);
     m_pGabiSearchAddr = NULL;
    }
    if (m_pVirtMemoryGABI != NULL)
    {
     vfree(m_pVirtMemoryGABI);
     m_pVirtMemoryGABI = NULL;
     m_fGabiExec = NULL;
    }
    if (m_pInOutBufferGABI != NULL)
    {
     kfree(m_pInOutBufferGABI);
     m_pInOutBufferGABI = NULL;
    }
    printk(KERN_INFO "smbus(%d): " "FindGabi(): WARNING: GABI Service NOT available (%d) !\n", (int)(jiffies-jiffies0), 3);
    return 0;
   }
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Entry  Point (m_fGabiExec)  = 0x%p\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: IoCtl  In/Out Buf Virt Addr = 0x%p\n", (int)(jiffies-jiffies0), m_pInOutBufferGABI); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: IoCtl  In/Out Buf Size      = 0x%08x\n", (int)(jiffies-jiffies0), 6*1024); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Cntrl  Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (unsigned int)m_GabiControlBuffer.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Cntrl  Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_GabiControlBuffer.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Cntrl  Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_GabiControlBuffer.PhysicalAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Input  Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (unsigned int)m_GabiRequestBuffer.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Input  Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_GabiRequestBuffer.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Input  Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_GabiRequestBuffer.PhysicalAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Output Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (unsigned int)m_GabiResponseBuffer.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Output Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_GabiResponseBuffer.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Output Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_GabiResponseBuffer.PhysicalAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: StPage Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (unsigned int)m_pGABIStaticPage.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: StPage Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_pGABIStaticPage.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: StPage Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_pGABIStaticPage.PhysicalAddress); } while (0);
   }
   return 1;
  }
  else
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABISearchAddress: GABI Signature not found!\n", (int)(jiffies-jiffies0)); } while (0);
  }
 }
 if (m_pGabiSearchAddr != NULL)
 {
  iounmap((void *) m_pGabiSearchAddr);
  m_pGabiSearchAddr = NULL;
 }
 return 0;
}
static noinline void DumpBytes (unsigned char traceLevel, unsigned char * pTitle, unsigned char *pMemory, size_t nrBytes)
{
 size_t offset;
 do { if (smbusDebug & (1 << (traceLevel))) printk(KERN_DEBUG "smbus(%d):" "%s\n", (int)(jiffies-jiffies0), pTitle); } while (0);
 for (offset=0; offset < nrBytes; offset += 0x10)
 {
  unsigned char * pB = (unsigned char *)pMemory + offset;
  do { if (smbusDebug & (1 << (traceLevel))) printk(KERN_DEBUG "smbus(%d):" "  %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n", (int)(jiffies-jiffies0), pB[0], pB[1], pB[2], pB[3], pB[4], pB[5], pB[6], pB[7], pB[8], pB[9], pB[10], pB[11], pB[12], pB[13], pB[14], pB[15]); } while (0);
 }
}
static noinline int GabiExecuteCommand (unsigned char * pInBuffer, unsigned int InDataSize,
        unsigned char * pOutBuffer, unsigned int OutBufferSize,
        unsigned int *ReturnDataSize)
{
 int success = 0;
 int useDataDescriptorList = 0;
 GABI_CONTROL_BUFFER *pCallerControlBuffer = NULL;
 GABI_DATA_BUFFER_COMMON_HEADER *pCallerRequestBuffer = NULL;
 GABI_DATA_BUFFER_COMMON_HEADER *pCallerResponseBuffer = NULL;
 unsigned long controlBufferInputSize = 0;
 unsigned long responseBufferSize = 0;
 unsigned short allocatedControlBufferSize = 0;
 unsigned short allocatedRequestBufferSize = 0;
 unsigned short allocatedResponseBufferSize = 0;
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pRequestDescriptorList = NULL;
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pResponseDescriptorList = NULL;
 GABI_DATA_BUFFER_DESCR_HEADER responseHeader;
 GABI_CONTROL_BUFFER *pCtrl = NULL;
 unsigned long ulPhysAddrCB = 0;
 unsigned long ulPhysAddrINB = 0;
 unsigned long ulPhysAddrOUTB = 0;
 int PrepBufOK = 0;
 *ReturnDataSize = 0;
 do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): enter, InDataSize=%d, OutBufferSize=%d...\n", (int)(jiffies-jiffies0), InDataSize, OutBufferSize); } while (0);
 do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand():   pInBuffer=%p, pOutBuffer=%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
 for (;;)
 {
  if (m_GabiControlBuffer.AllocatedSize == 0 || m_GabiRequestBuffer.AllocatedSize == 0 || m_GabiResponseBuffer.AllocatedSize == 0 || m_pGABIStaticPage.AllocatedSize == 0)
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! One of the allocated static buffers is not available! (%ld, %ld, %ld, %ld)\n", (int)(jiffies-jiffies0), m_GabiControlBuffer.AllocatedSize, m_GabiRequestBuffer.AllocatedSize, m_GabiResponseBuffer.AllocatedSize, m_pGABIStaticPage.AllocatedSize); } while (0);
   return 0;
  }
  if (smbusDebug> 0)
  {
   DumpBytes (5, "Input data dump:\n", pInBuffer, 0x80);
  }
  memset (m_GabiControlBuffer.pVirtualAddress, 0, m_GabiControlBuffer.AllocatedSize);
  memset (m_GabiRequestBuffer.pVirtualAddress, 0, m_GabiRequestBuffer.AllocatedSize);
  memset (m_GabiResponseBuffer.pVirtualAddress, 0, m_GabiResponseBuffer.AllocatedSize);
  pCallerControlBuffer = (GABI_CONTROL_BUFFER *)pInBuffer;
  pCallerRequestBuffer = (GABI_DATA_BUFFER_COMMON_HEADER *)(pInBuffer + pCallerControlBuffer->AllocatedBufferSize);
  pCallerResponseBuffer = (GABI_DATA_BUFFER_COMMON_HEADER *)(pOutBuffer + pCallerControlBuffer->AllocatedBufferSize);
  if (InDataSize < pCallerControlBuffer->AllocatedBufferSize + (((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data)))
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Input buffer too small (%d) to contain a control and a request buffer!\n", (int)(jiffies-jiffies0), InDataSize); } while (0);
   break;
  }
  if (OutBufferSize < pCallerControlBuffer->AllocatedBufferSize + (((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data)))
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Output buffer too small (%d) to contain a control and a response buffer!\n", (int)(jiffies-jiffies0), OutBufferSize); } while (0);
   break;
  }
  if (pCallerControlBuffer->AllocatedBufferSize < (((size_t) &((GABI_CONTROL_BUFFER *)0)->BiosScratchBuffer)))
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Input buffer smaller than minimum control buffer size (%ld)!\n", (int)(jiffies-jiffies0), (unsigned long)(((size_t) &((GABI_CONTROL_BUFFER *)0)->BiosScratchBuffer))); } while (0);
   break;
  }
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): control buffer size  : 0x%04X\n", (int)(jiffies-jiffies0), pCallerControlBuffer->AllocatedBufferSize); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service category code: 0x%04X\n", (int)(jiffies-jiffies0), pCallerControlBuffer->ServiceCategoryCode); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service code         : 0x%04X\n", (int)(jiffies-jiffies0), pCallerControlBuffer->ServiceCode); } while (0);
  }
  if ( pCallerControlBuffer->ServiceCategoryCode == 0x0007 ||
   (pCallerControlBuffer->ServiceCategoryCode & 0xfe00) == 0x8200)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Use memory descriptor list as request/response data!\n", (int)(jiffies-jiffies0)); } while (0);
   useDataDescriptorList = 1;
  }
  else
  {
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Use plain request/response data (no descriptor list) (%d)\n", (int)(jiffies-jiffies0), useDataDescriptorList); } while (0);
  }
  controlBufferInputSize = pCallerControlBuffer->AllocatedBufferSize;
  responseBufferSize = OutBufferSize - controlBufferInputSize;
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "  given control buffer size = %ld\n", (int)(jiffies-jiffies0), controlBufferInputSize); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "  given response buffer size = %ld\n", (int)(jiffies-jiffies0), responseBufferSize); } while (0);
  }
  if (responseBufferSize > 0xffff)
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Supplied response buffer size (%ld) > maximum of 64kB!\n", (int)(jiffies-jiffies0), responseBufferSize); } while (0);
   responseBufferSize = 0xffff;
  }
  allocatedControlBufferSize = pCallerControlBuffer->AllocatedBufferSize;
  allocatedRequestBufferSize = pCallerRequestBuffer->AllocatedBufferSize;
  allocatedResponseBufferSize = (unsigned short)responseBufferSize;
  if (allocatedControlBufferSize > m_GabiControlBuffer.AllocatedSize)
  {
   allocatedControlBufferSize = (unsigned short)m_GabiControlBuffer.AllocatedSize;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Control buffer size (%d) > static GABI control buffer size - truncated!\n", (int)(jiffies-jiffies0), allocatedControlBufferSize); } while (0);
   break;
  }
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  allocated control buffer size = %d\n", (int)(jiffies-jiffies0), allocatedControlBufferSize); } while (0);
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  allocated request buffer size = %d\n", (int)(jiffies-jiffies0), allocatedRequestBufferSize); } while (0);
  }
  pCallerControlBuffer->GeneralStatus = 0;
  pCallerControlBuffer->ErrorCode = 0;
  memcpy (m_GabiControlBuffer.pVirtualAddress, pCallerControlBuffer, allocatedControlBufferSize);
  ((GABI_DATA_BUFFER_COMMON_HEADER *)m_GabiControlBuffer.pVirtualAddress)->AllocatedBufferSize = (unsigned short)m_GabiControlBuffer.AllocatedSize;
  pRequestDescriptorList = NULL;
  pResponseDescriptorList = NULL;
  if (useDataDescriptorList)
  {
   pRequestDescriptorList = GabiAllocateDescriptorList();
   pResponseDescriptorList = GabiAllocateDescriptorList();
   if (pRequestDescriptorList == NULL || pResponseDescriptorList == NULL)
    break;
   if (pCallerRequestBuffer->AllocatedBufferSize < (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Request buffer size (%d) smaller than minimum header for buffer descriptors!\n", (int)(jiffies-jiffies0), pCallerRequestBuffer->AllocatedBufferSize); } while (0);
    break;
   }
   if (responseBufferSize < (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Response buffer size (%ld) smaller than minimum header for buffer descriptors!\n", (int)(jiffies-jiffies0), responseBufferSize); } while (0);
    break;
   }
  }
  PrepBufOK = GabiPrepareGabiBuffer (&m_GabiRequestBuffer, pCallerRequestBuffer, pRequestDescriptorList, "RequestBuffer", 1);
  memset (&responseHeader, 0, sizeof (responseHeader));
  responseHeader.AllocatedBufferSize = allocatedResponseBufferSize;
  if (useDataDescriptorList)
  {
   responseHeader.StructureVersion = (unsigned short)1;
   responseHeader.TransactionHandle = 0;
   responseHeader.DataSize = allocatedResponseBufferSize - (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data));
  }
  PrepBufOK = GabiPrepareGabiBuffer (&m_GabiResponseBuffer, (GABI_DATA_BUFFER_COMMON_HEADER *)&responseHeader, pResponseDescriptorList, "ResponseBuffer", 0);
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "Request buffer virtual addr = 0x%p, phys addr = 0x%016llx, alloc size = %ld\n", (int)(jiffies-jiffies0), m_GabiRequestBuffer.pVirtualAddress, m_GabiRequestBuffer.PhysicalAddress, m_GabiRequestBuffer.AllocatedSize); } while (0);
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "Response buffer virtual addr = 0x%p, phys addr = 0x%016llx, alloc size = %ld\n", (int)(jiffies-jiffies0), m_GabiResponseBuffer.pVirtualAddress, m_GabiResponseBuffer.PhysicalAddress, m_GabiResponseBuffer.AllocatedSize); } while (0);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Dumps of GABI buffers before request...", (int)(jiffies-jiffies0)); } while (0);
   DumpBytes (6, "Control buffer:\n", m_GabiControlBuffer.pVirtualAddress, 0x20);
   DumpBytes (6, "Request buffer:\n", m_GabiRequestBuffer.pVirtualAddress, 0x20);
   DumpBytes (6, "Response buffer:\n", m_GabiResponseBuffer.pVirtualAddress, 0x20);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
  }
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): call GABI...(0x%p)\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
  ulPhysAddrINB = (unsigned long) m_GabiRequestBuffer.PhysicalAddress;
  ulPhysAddrOUTB = (unsigned long) m_GabiResponseBuffer.PhysicalAddress;
  ulPhysAddrCB = (unsigned long) m_GabiControlBuffer.PhysicalAddress;
  smbus_CallGabi(ulPhysAddrINB, ulPhysAddrOUTB, ulPhysAddrCB, (GABI_CMD_ROUTINE_VOID)m_fGabiExec);
  do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ...back from GABI (0x%p)\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
  if (smbusDebug> 0)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Dumps of GABI buffers after request...", (int)(jiffies-jiffies0)); } while (0);
   DumpBytes (6, "Control buffer:\n", m_GabiControlBuffer.pVirtualAddress, 0x20);
   DumpBytes (6, "Response buffer:\n", m_GabiResponseBuffer.pVirtualAddress, 0x20);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
  }
  pCtrl = (GABI_CONTROL_BUFFER *)m_GabiControlBuffer.pVirtualAddress;
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): control buffer size  : %04X\n", (int)(jiffies-jiffies0), pCtrl->AllocatedBufferSize); } while (0);
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service category code: %04X\n", (int)(jiffies-jiffies0), pCtrl->ServiceCategoryCode); } while (0);
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service code         : %04X\n", (int)(jiffies-jiffies0), pCtrl->ServiceCode); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  general status       : %04X\n", (int)(jiffies-jiffies0), pCtrl->GeneralStatus); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  error code           : %04X\n", (int)(jiffies-jiffies0), pCtrl->ErrorCode); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  action code          : %04X\n", (int)(jiffies-jiffies0), pCtrl->ActionCode); } while (0);
  }
  pCallerControlBuffer = (GABI_CONTROL_BUFFER *)pOutBuffer;
  memcpy (pCallerControlBuffer, m_GabiControlBuffer.pVirtualAddress, allocatedControlBufferSize);
  pCallerControlBuffer->AllocatedBufferSize = allocatedControlBufferSize;
  pCallerResponseBuffer->AllocatedBufferSize = allocatedResponseBufferSize;
  PrepBufOK = GabiReturnGabiBuffer (&m_GabiResponseBuffer, pCallerResponseBuffer, pResponseDescriptorList);
  *ReturnDataSize = controlBufferInputSize + pCallerResponseBuffer->AllocatedBufferSize;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): %d bytes copied to output buffer\n", (int)(jiffies-jiffies0), *ReturnDataSize); } while (0);
  success = 1;
  if (useDataDescriptorList)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): free allocated descriptor lists\n", (int)(jiffies-jiffies0)); } while (0);
   GabiFreeDescriptorLists (pRequestDescriptorList);
   pRequestDescriptorList = NULL;
   GabiFreeDescriptorLists (pResponseDescriptorList);
   pResponseDescriptorList = NULL;
   m_pFreeVirtStMemGABI = m_pGABIStaticPage.pVirtualAddress;
   m_pFreePhysStMemGABI = m_pGABIStaticPage.PhysicalAddress;
   m_FreeStMemGABI = 4*1024;
  }
  break;
 }
 if (useDataDescriptorList)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): free allocated descriptor lists\n", (int)(jiffies-jiffies0)); } while (0);
  if (pRequestDescriptorList != NULL)
  {
   GabiFreeDescriptorLists (pRequestDescriptorList);
   pRequestDescriptorList = NULL;
  }
  if (pResponseDescriptorList != NULL)
  {
   GabiFreeDescriptorLists (pResponseDescriptorList);
   pResponseDescriptorList = NULL;
  }
  m_pFreeVirtStMemGABI = m_pGABIStaticPage.pVirtualAddress;
  m_pFreePhysStMemGABI = m_pGABIStaticPage.PhysicalAddress;
  m_FreeStMemGABI = 4*1024;
 }
 return success;
}
static noinline int GabiPrepareGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pInputDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList, const char * pBufferName, int copyRequestData)
{
 int success = 1;
 if (pDescriptorList == NULL)
 {
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "PrepareGabiBuffer \"%s\" - with flat data\n", (int)(jiffies-jiffies0), pBufferName); } while (0);
  if (copyRequestData)
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  copy header and data (%d bytes)\n", (int)(jiffies-jiffies0), pInputDataBuffer->AllocatedBufferSize); } while (0);
   memcpy (bufferDescr->pVirtualAddress, pInputDataBuffer, pInputDataBuffer->AllocatedBufferSize);
  }
  else
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  copy header only (%ld bytes)\n", (int)(jiffies-jiffies0), (unsigned long)(((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data))); } while (0);
   memcpy (bufferDescr->pVirtualAddress, pInputDataBuffer, (((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data)));
  }
  if (smbusDebug> 0)
  {
   DumpBytes (6, "Input data:\n", bufferDescr->pVirtualAddress, 0x30);
  }
 }
 else
 {
  GABI_DATA_BUFFER_DESCR_HEADER *pInputData = NULL;
  GABI_DATA_BUFFER_DESCR_HEADER *pGabiBuffer = NULL;
  unsigned int requiredDataSize = 0;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "PrepareGabiBuffer \"%s\" - with descriptor list\n", (int)(jiffies-jiffies0), pBufferName); } while (0);
  pInputData = (GABI_DATA_BUFFER_DESCR_HEADER *)pInputDataBuffer;
  pGabiBuffer = (GABI_DATA_BUFFER_DESCR_HEADER *)bufferDescr->pVirtualAddress;
  memcpy (pGabiBuffer, pInputData, (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)));
  pGabiBuffer->AllocatedBufferSize = (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)) + (sizeof (GABISYS_DATA_DESCRIPTOR));
  requiredDataSize = (unsigned int)pInputData->DataSize;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  required data size = 0x%04x\n", (int)(jiffies-jiffies0), requiredDataSize); } while (0);
  if (requiredDataSize > 0)
  {
   GABISYS_DATA_DESCRIPTOR *pCurrentGabiDescriptor = NULL;
   unsigned long dataStartOffset = 0;
   unsigned long freeSpaceInDataBuffer = 0;
   unsigned int nrGabiDecriptorBlocks = 0;
   dataStartOffset = pGabiBuffer->AllocatedBufferSize + (sizeof (GABISYS_DATA_DESCRIPTOR));
   freeSpaceInDataBuffer = bufferDescr->AllocatedSize - dataStartOffset;
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  data offset = 0x%08x\n", (int)(jiffies-jiffies0), (unsigned int)dataStartOffset); } while (0);
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  free space in data buffer = 0x%08x\n", (int)(jiffies-jiffies0), (unsigned int)freeSpaceInDataBuffer); } while (0);
   nrGabiDecriptorBlocks = 0;
   pCurrentGabiDescriptor = (GABISYS_DATA_DESCRIPTOR *)pGabiBuffer->Data;
   if (requiredDataSize < freeSpaceInDataBuffer)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> descriptor data buffer fits in response buffer - use that buffer and create descriptor\n", (int)(jiffies-jiffies0)); } while (0);
    pDescriptorList->ActNumberOfEntries = -1;
    pDescriptorList->pNext = NULL;
    pDescriptorList->Descriptor[0].AllocatedSize = requiredDataSize;
    pDescriptorList->Descriptor[0].PhysicalAddress = bufferDescr->PhysicalAddress + dataStartOffset;
    pDescriptorList->Descriptor[0].pVirtualAddress = (unsigned char *)bufferDescr->pVirtualAddress + dataStartOffset;
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  descriptor[0]: size = 0x%08x, phys addr = 0x%016llx, virtual addr = 0x%p\n", (int)(jiffies-jiffies0), (unsigned int) pDescriptorList->Descriptor[0].AllocatedSize, pDescriptorList->Descriptor[0].PhysicalAddress, pDescriptorList->Descriptor[0].pVirtualAddress); } while (0);
    pCurrentGabiDescriptor->BlockSize = pDescriptorList->Descriptor[0].AllocatedSize;
    pCurrentGabiDescriptor->BlockAddressPhysical = pDescriptorList->Descriptor[0].PhysicalAddress;
    nrGabiDecriptorBlocks = 1;
    if (copyRequestData)
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> copy request data into the GABI buffer\n", (int)(jiffies-jiffies0)); } while (0);
     memcpy (pDescriptorList->Descriptor[0].pVirtualAddress, pInputData->Data, requiredDataSize);
     if (smbusDebug> 0)
     {
      DumpBytes (6, "Request data:\n", pDescriptorList->Descriptor[0].pVirtualAddress, requiredDataSize);
     }
    }
    else
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  just create the descriptor list\n", (int)(jiffies-jiffies0)); } while (0);
    }
   }
   else
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> descriptor data buffer does not fit into response buffer - allocate extra buffer(s)\n", (int)(jiffies-jiffies0)); } while (0);
    if ((m_pFreeVirtStMemGABI == NULL) || (m_FreeStMemGABI == 0) ||
     (requiredDataSize > (4*1024 / 2)) || (requiredDataSize > m_FreeStMemGABI))
    {
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "  ## WARNING: cannot fulfill this request. Not enough memory available (req=%d, avail=%d, virt=%p)\n", (int)(jiffies-jiffies0), requiredDataSize, m_FreeStMemGABI, m_pFreeVirtStMemGABI); } while (0);
     success = 0;
     return 0;
    }
    else
    {
     unsigned char *pMem = NULL;
     PHYSICAL_MEMORY_DESCRIPTOR *pdescr = NULL;
     pDescriptorList->ActNumberOfEntries = 0;
     pMem = (unsigned char *) m_pFreeVirtStMemGABI;
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "      alloc succeeded, add buffer to descriptor list\n", (int)(jiffies-jiffies0)); } while (0);
     if (pDescriptorList->ActNumberOfEntries >= pDescriptorList->MaxEntries)
     {
      PHYSICAL_MEMORY_DESCRIPTOR_LIST *pNewDescriptorList = NULL;
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "    internal descriptor table is full, allocate a new one...\n", (int)(jiffies-jiffies0)); } while (0);
      pNewDescriptorList = GabiAllocateDescriptorList();
      do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "    -> new descriptor list allocated at 0x%p\n", (int)(jiffies-jiffies0), pNewDescriptorList); } while (0);
      if (pNewDescriptorList)
      {
       pDescriptorList->pNext = pNewDescriptorList;
       pDescriptorList = pNewDescriptorList;
      }
      else
      {
       do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::PrepareGabiBuffer(): Failed to allocate another descriptor table!!\n", (int)(jiffies-jiffies0)); } while (0);
       success = 0;
       return 0;
      }
     }
     pdescr = &(pDescriptorList->Descriptor[pDescriptorList->ActNumberOfEntries]);
     pDescriptorList->ActNumberOfEntries++;
     pdescr->AllocatedSize = requiredDataSize;
     pdescr->pVirtualAddress = pMem;
     pdescr->PhysicalAddress = m_pFreePhysStMemGABI;
     do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "    added memory block #%d to descriptor list; size=%ld, phys addr=0x%016llx, virt addr=0x%p\n", (int)(jiffies-jiffies0), nrGabiDecriptorBlocks, pdescr->AllocatedSize, pdescr->PhysicalAddress, pdescr->pVirtualAddress); } while (0);
     pCurrentGabiDescriptor->BlockAddressPhysical = pdescr->PhysicalAddress;
     pCurrentGabiDescriptor->BlockSize = pdescr->AllocatedSize;
     pCurrentGabiDescriptor++;
     nrGabiDecriptorBlocks++;
     if (copyRequestData)
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "    -> copy memory block to GABI buffer", (int)(jiffies-jiffies0)); } while (0);
      memcpy (pMem, pInputData->Data, requiredDataSize);
      if (smbusDebug> 0)
      {
       DumpBytes (6, "Input data:\n", pMem, requiredDataSize);
      }
     }
     m_FreeStMemGABI = m_FreeStMemGABI - requiredDataSize;
     if (m_FreeStMemGABI > 0)
     {
      m_pFreeVirtStMemGABI = m_pFreeVirtStMemGABI + requiredDataSize;
      m_pFreePhysStMemGABI = m_pFreePhysStMemGABI + requiredDataSize;
      do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "memory of Gabi Static page still available (%d, VirtAddr=0x%p, PhysAddr = 0x%016lx\n", (int)(jiffies-jiffies0), m_FreeStMemGABI, m_pFreeVirtStMemGABI, m_pFreePhysStMemGABI); } while (0);
     }
     else
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## WARNING: all memory from Gabi Static page consumed !\n", (int)(jiffies-jiffies0)); } while (0);
      m_FreeStMemGABI = 0;
      m_pFreeVirtStMemGABI = NULL;
      m_pFreePhysStMemGABI = 0;
     }
    }
   }
   pGabiBuffer->AllocatedBufferSize = (unsigned short)((((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)) + (nrGabiDecriptorBlocks * (sizeof (GABISYS_DATA_DESCRIPTOR))));
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  allocated buffer size (with descriptors) = 0x%04x\n", (int)(jiffies-jiffies0), pGabiBuffer->AllocatedBufferSize); } while (0);
   if (smbusDebug> 0)
   {
    DumpBytes (6, "Descriptor table dump:\n", pGabiBuffer->Data, nrGabiDecriptorBlocks * sizeof (PHYSICAL_MEMORY_DESCRIPTOR));
   }
  }
 }
 return success;
}
static noinline int GabiReturnGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pReturnDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList)
{
 int success = 0;
 if (pDescriptorList == NULL)
 {
  GABI_DATA_BUFFER_COMMON_HEADER *pGabiBuffer = NULL;
  unsigned int returnBufferSize = 0;
  unsigned int returnDataSize = 0;
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "ReturnGabiBuffer - with flat data\n", (int)(jiffies-jiffies0)); } while (0);
  pGabiBuffer = (GABI_DATA_BUFFER_COMMON_HEADER *)bufferDescr->pVirtualAddress;
  returnBufferSize = pReturnDataBuffer->AllocatedBufferSize;
  returnDataSize = pGabiBuffer->AllocatedBufferSize;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "ReturnGabiBuffer:   return data size = %d, return buffer size = %d\n", (int)(jiffies-jiffies0), returnDataSize, returnBufferSize); } while (0);
  if (returnDataSize > returnBufferSize)
  {
   returnDataSize = returnBufferSize;
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Returned data size > return buffer size - return data will be cut!!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  return %d bytes of data directly from GABI buffer\n", (int)(jiffies-jiffies0), returnDataSize); } while (0);
  memcpy (pReturnDataBuffer, pGabiBuffer, returnDataSize);
  if (smbusDebug> 0)
  {
   DumpBytes (6, "Response data:\n", (unsigned char *)pReturnDataBuffer, returnDataSize);
  }
  success = 1;
 }
 else
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "ReturnGabiBuffer - with descriptor list\n", (int)(jiffies-jiffies0)); } while (0);
  if (pReturnDataBuffer->AllocatedBufferSize >= (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)))
  {
   GABI_DATA_BUFFER_DESCR_HEADER *pReturnDataBufferDescr = NULL;
   GABI_DATA_BUFFER_DESCR_HEADER *pGabiBuffer = NULL;
   unsigned int returnBufferSize = 0;
   unsigned int returnDataSize = 0;
   pReturnDataBufferDescr = (GABI_DATA_BUFFER_DESCR_HEADER *)pReturnDataBuffer;
   pGabiBuffer = (GABI_DATA_BUFFER_DESCR_HEADER *)bufferDescr->pVirtualAddress;
   returnBufferSize = pReturnDataBuffer->AllocatedBufferSize - (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data));
   returnDataSize = (unsigned int)pGabiBuffer->DataSize;
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  allocated data size = 0x%04x\n", (int)(jiffies-jiffies0), pReturnDataBuffer->AllocatedBufferSize); } while (0);
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  response buffer size = 0x%04x\n", (int)(jiffies-jiffies0), returnBufferSize); } while (0);
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  response data size (supplied by GABI) = 0x%04x\n", (int)(jiffies-jiffies0), returnDataSize); } while (0);
   }
   memcpy (pReturnDataBufferDescr, pGabiBuffer, (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)));
   if (pDescriptorList->ActNumberOfEntries == -1)
   {
    unsigned int descrDataSize = 0;
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> one single data block within GABI buffer (following descriptor table)\n", (int)(jiffies-jiffies0)); } while (0);
    descrDataSize = (unsigned int)pDescriptorList->Descriptor[0].AllocatedSize;
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  data size (in descriptor) = 0x%08x\n", (int)(jiffies-jiffies0), descrDataSize); } while (0);
    if (returnDataSize)
    {
     if (returnDataSize > descrDataSize)
     {
      returnDataSize = descrDataSize;
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Response data size > descriptor buffer size - return data will be cut!!\n", (int)(jiffies-jiffies0)); } while (0);
     }
     if (returnDataSize > returnBufferSize)
     {
      returnDataSize = returnBufferSize;
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Response data size > response buffer size - return data will be cut!!\n", (int)(jiffies-jiffies0)); } while (0);
     }
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  copy response data...\n", (int)(jiffies-jiffies0)); } while (0);
     memcpy (pReturnDataBufferDescr->Data, pDescriptorList->Descriptor[0].pVirtualAddress, returnDataSize);
     if (smbusDebug> 0)
     {
      DumpBytes (6, "Response data:\n", pReturnDataBufferDescr->Data, returnDataSize);
     }
     success = 1;
    }
   }
   else if (pDescriptorList->ActNumberOfEntries > 0)
   {
    size_t remainingDataSize = returnDataSize;
    unsigned long offset = 0;
    INT_PTR descrEntryIndex = 0;
    INT_PTR nrGabiDecriptorBlocks = 0;
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> multiple allocated data blocks", (int)(jiffies-jiffies0)); } while (0);
    success = 1;
    while (remainingDataSize > 0)
    {
     PHYSICAL_MEMORY_DESCRIPTOR *pdescr = NULL;
     if (descrEntryIndex >= pDescriptorList->ActNumberOfEntries)
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "    -> next descriptor list", (int)(jiffies-jiffies0)); } while (0);
      pDescriptorList = pDescriptorList->pNext;
      descrEntryIndex = 0;
     }
     if (pDescriptorList == NULL)
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Not enough descriptors available for returning data!!\n", (int)(jiffies-jiffies0)); } while (0);
      success = 0;
      break;
     }
     pdescr = &pDescriptorList->Descriptor[descrEntryIndex];
     do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "    descriptor [%d]: size = %ld, phys addr = 0x%016llx, virt addr = 0x%p", (int)(jiffies-jiffies0), nrGabiDecriptorBlocks, pdescr->AllocatedSize, pdescr->PhysicalAddress, pdescr->pVirtualAddress); } while (0);
     if (pdescr->AllocatedSize && pdescr->pVirtualAddress)
     {
      unsigned int nrBytes = 0;
      nrBytes = (remainingDataSize < pdescr->AllocatedSize) ? remainingDataSize : pdescr->AllocatedSize;
      memcpy (pReturnDataBufferDescr->Data + offset, pdescr->pVirtualAddress, nrBytes);
      if (smbusDebug> 0)
      {
       DumpBytes (6, "Return data:\n", pReturnDataBufferDescr->Data + offset, nrBytes);
      }
      remainingDataSize -= nrBytes;
      offset += nrBytes;
     }
     else
     {
      do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): size or address in descriptor #%d is zero!!\n", (int)(jiffies-jiffies0), nrGabiDecriptorBlocks); } while (0);
      success = 0;
      break;
     }
     descrEntryIndex++;
     nrGabiDecriptorBlocks++;
    }
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  total number bytes copied = %ld", (int)(jiffies-jiffies0), offset); } while (0);
   }
   else
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  no return data\n", (int)(jiffies-jiffies0)); } while (0);
   }
   pReturnDataBuffer->AllocatedBufferSize = (unsigned short)((((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)) + returnDataSize);
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Response buffer size too small to keep at least response header!\n", (int)(jiffies-jiffies0)); } while (0);
  }
 }
 return success;
}
static noinline PHYSICAL_MEMORY_DESCRIPTOR_LIST *GabiAllocateDescriptorList(void)
{
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList = NULL;
 pDescriptorList = (PHYSICAL_MEMORY_DESCRIPTOR_LIST *)kmalloc(sizeof(PHYSICAL_MEMORY_DESCRIPTOR_LIST), GFP_USER);
 do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "Allocated data descriptor list, address = 0x%p, size = %ld\n", (int)(jiffies-jiffies0), pDescriptorList, (unsigned long)sizeof(PHYSICAL_MEMORY_DESCRIPTOR_LIST)); } while (0);
 if (pDescriptorList)
 {
  memset (pDescriptorList, 0, sizeof (PHYSICAL_MEMORY_DESCRIPTOR_LIST));
  pDescriptorList->MaxEntries = 3;
  pDescriptorList->ActNumberOfEntries = -1;
 }
 else
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "CGabi::ExecuteCommand(): ## ERROR! Failed to allocate data descriptor list!\n", (int)(jiffies-jiffies0)); } while (0);
 }
 return pDescriptorList;
}
static noinline void GabiFreeDescriptorLists (PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList)
{
 PHYSICAL_MEMORY_DESCRIPTOR *pdescr = NULL;
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pNextList = NULL;
 unsigned int nrDecriptorBlocks = 0;
 INT_PTR i;
 if ((pDescriptorList != NULL) && (pDescriptorList->ActNumberOfEntries == -1))
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> In/Out-Buffer free space has been used in this DescriptorList, with only ony Descriptor\n", (int)(jiffies-jiffies0)); } while (0);
  pdescr = &pDescriptorList->Descriptor[0];
  pdescr->AllocatedSize = 0;
  pdescr->PhysicalAddress = 0;
  pdescr->pVirtualAddress = NULL;
  kfree (pDescriptorList);
 }
 else
 {
  while (pDescriptorList != NULL)
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiFreeDescriptorLists(): free descriptor list... 0x%p\n", (int)(jiffies-jiffies0), pDescriptorList); } while (0);
   for (i=0; i < pDescriptorList->ActNumberOfEntries; i++)
   {
    pdescr = &pDescriptorList->Descriptor[i];
    do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  free descriptor [%d]: size = %ld, phys addr = 0x%016llx, virt addr = 0x%p", (int)(jiffies-jiffies0), nrDecriptorBlocks, pdescr->AllocatedSize, pdescr->PhysicalAddress, pdescr->pVirtualAddress); } while (0);
    pdescr->AllocatedSize = 0;
    pdescr->PhysicalAddress = 0;
    pdescr->pVirtualAddress = NULL;
    nrDecriptorBlocks++;
   }
   pNextList = pDescriptorList->pNext;
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  free allocated descriptor list at address 0x%p", (int)(jiffies-jiffies0), pDescriptorList); } while (0);
   kfree (pDescriptorList);
   pDescriptorList = pNextList;
  }
 }
}
noinline void smbus_CallGabi(unsigned long InBuffer, unsigned long OutBuffer, unsigned long ControlBuffer, GABI_CMD_ROUTINE_VOID GabiEx)
{
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CallGabi: InBuf=0x%016lX, OutBuf=0x%016lX, CntlBuf=0x%016lX, GabiEx=0x%p, *GabiEx=0x%p\n", (int)(jiffies-jiffies0), InBuffer, OutBuffer, ControlBuffer, GabiEx, *GabiEx); } while (0);
 ASMX86(PUSH_RRDX
  :
  : "d" (ControlBuffer));
 ASMX86(PUSH_RRSI
  :
  : "S" (OutBuffer));
 ASMX86(PUSH_RRDI
  :
  : "D" (InBuffer));
 (*(GABI_CMD_ROUTINE_VOID)m_fGabiExec)();
 ASMX86(POP_RRDI);
 ASMX86(POP_RRSI);
 ASMX86(POP_RRDX);
}
static noinline void ReadFromIndexedPort(IOCTLDATA_INDEXED_PORT_IO *portio)
{
 outb_p(portio->IndexData, portio->IndexPort);
 portio->DataData = inb_p(portio->DataPort);
}
static noinline void WriteToIndexedPort(IOCTLDATA_INDEXED_PORT_IO *portio)
{
 outb_p(portio->IndexData, portio->IndexPort);
 outb_p(portio->DataData, portio->DataPort);
}
void noinline smbus_ReadCpuInfo_callback (void *pent)
{
 int sparse;
 int dense;
 CpuInfo *pentry = pent;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pentry->DenseCpuNr == dense)
 {
  pentry->SparseCpuNr = sparse;
  smbus_CpuId(0x00000000, &pentry->regs0);
  if (pentry->regs0.eax >= 0x00000001)
  {
   smbus_CpuId(0x00000001, &pentry->regs1);
   pentry->regs1Valid = 1;
   pentry->LocalApicSupported = !!(pentry->regs1.edx & (1<<9));
   pentry->MachineCheckArchitectureSupported = !!(pentry->regs1.edx & (1<<14));
   pentry->NumberLogicalCpus = (unsigned int)(((pentry->regs1.ebx) >> 16) & 0xFF);
   pentry->LocalApicIdInitial = (unsigned int)(((pentry->regs1.ebx) >> 24) & 0xFF);
   pentry->PrimaryLogicalCpu = !!(pentry->NumberLogicalCpus == 0 ||
                pentry->NumberLogicalCpus == 1 ||
                !(pentry->LocalApicIdInitial & 0x01));
   if (pentry->regs0.eax >= 0x00000002)
   {
    smbus_CpuId(0x00000002, &pentry->regs2);
    pentry->regs2Valid = 1;
    if (pentry->regs0.eax >= 0x00000003)
    {
     smbus_CpuId(0x00000003, &pentry->regs3);
     pentry->regs3Valid = 0;
     if (pentry->regs0.eax >= 0x00000004)
     {
      smbus_CpuId(0x00000004, &pentry->regs4);
      pentry->regs4Valid = 1;
     }
    }
   }
  }
  smbus_CpuId(0x80000000, &pentry->MaxExtentions);
  if (pentry->MaxExtentions.eax >= 0x80000004)
  {
   smbus_CpuId(0x80000002, &pentry->BrandString1);
   smbus_CpuId(0x80000003, &pentry->BrandString2);
   smbus_CpuId(0x80000004, &pentry->BrandString3);
   pentry->BrandStringValid = 1;
   if (pentry->MaxExtentions.eax >= 0x80000008)
   {
    smbus_CpuId(0x80000008, &pentry->NrCoresAMD);
    pentry->NrCoresAMDValid = 1;
   }
  }
  if (pentry->LocalApicSupported &&
   pentry->MachineCheckArchitectureSupported)
  {
   pentry->ApicBaseMsr = smbus_ReadMsr(0x01B);
   pentry->ApicBaseAddress = ((((pentry->ApicBaseMsr))) & ((unsigned long long)0xffffff)<<12);
   pentry->BootstrapCpu = !!((unsigned char)((((pentry->ApicBaseMsr)) >> 8) & 1));
   pentry->ApicGlobalEnable = !!((unsigned char)((((pentry->ApicBaseMsr)) >> 11) & 1));
   pentry->x2ApicMode = !!((unsigned char)((((pentry->ApicBaseMsr)) >> 10) & 1));
   if (pentry->ApicGlobalEnable && pentry->x2ApicMode)
   {
    pentry->x2ApicLocalApicId = smbus_ReadMsr(0x802);
    pentry->ApicId = (unsigned int) pentry->x2ApicLocalApicId;
    pentry->ApicIdValid = 1;
   }
   else
   {
    pentry->ApicIdValid = 0;
   }
  }
 }
 return;
}
static noinline void smbus_do_ReadCpuInfo(CpuInfo *pentry)
{
 int sparse;
 int dense;
 PREEMPT_DISABLE;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pentry->DenseCpuNr == dense)
 {
  pentry->SparseCpuNr = sparse;
  smbus_CpuId(0x00000000, &pentry->regs0);
  if (pentry->regs0.eax >= 0x00000001)
  {
   smbus_CpuId(0x00000001, &pentry->regs1);
   pentry->regs1Valid = 1;
   pentry->LocalApicSupported = !!(pentry->regs1.edx & (1<<9));
   pentry->MachineCheckArchitectureSupported = !!(pentry->regs1.edx & (1<<14));
   pentry->NumberLogicalCpus = (unsigned int)(((pentry->regs1.ebx) >> 16) & 0xFF);
   pentry->LocalApicIdInitial = (unsigned int)(((pentry->regs1.ebx) >> 24) & 0xFF);
   pentry->PrimaryLogicalCpu = !!(pentry->NumberLogicalCpus == 0 ||
                pentry->NumberLogicalCpus == 1 ||
                !(pentry->LocalApicIdInitial & 0x01));
   if (pentry->regs0.eax >= 0x00000002)
   {
    smbus_CpuId(0x00000002, &pentry->regs2);
    pentry->regs2Valid = 1;
    if (pentry->regs0.eax >= 0x00000003)
    {
     smbus_CpuId(0x00000003, &pentry->regs3);
     pentry->regs3Valid = 0;
     if (pentry->regs0.eax >= 0x00000004)
     {
      smbus_CpuId(0x00000004, &pentry->regs4);
      pentry->regs4Valid = 1;
     }
    }
   }
  }
  smbus_CpuId(0x80000000, &pentry->MaxExtentions);
  if (pentry->MaxExtentions.eax >= 0x80000004)
  {
   smbus_CpuId(0x80000002, &pentry->BrandString1);
   smbus_CpuId(0x80000003, &pentry->BrandString2);
   smbus_CpuId(0x80000004, &pentry->BrandString3);
   pentry->BrandStringValid = 1;
   if (pentry->MaxExtentions.eax >= 0x80000008)
   {
    smbus_CpuId(0x80000008, &pentry->NrCoresAMD);
    pentry->NrCoresAMDValid = 1;
   }
  }
  if (pentry->LocalApicSupported &&
   pentry->MachineCheckArchitectureSupported)
  {
   pentry->ApicBaseMsr = smbus_ReadMsr(0x01B);
   pentry->ApicBaseAddress = ((((pentry->ApicBaseMsr))) & ((unsigned long long)0xffffff)<<12);
   pentry->BootstrapCpu = !!((unsigned char)((((pentry->ApicBaseMsr)) >> 8) & 1));
   pentry->ApicGlobalEnable = !!((unsigned char)((((pentry->ApicBaseMsr)) >> 11) & 1));
   pentry->x2ApicMode = !!((unsigned char)((((pentry->ApicBaseMsr)) >> 10) & 1));
   if (pentry->ApicGlobalEnable && pentry->x2ApicMode)
   {
    pentry->x2ApicLocalApicId = smbus_ReadMsr(0x802);
    pentry->ApicId = (unsigned int) pentry->x2ApicLocalApicId;
    pentry->ApicIdValid = 1;
   }
   else
   {
    pentry->ApicIdValid = 0;
   }
  }
 }
 else
 {
  SMP_CALL_FUNCTION(smbus_ReadCpuInfo_callback, (void *)pentry, 1, 1);
 }
 PREEMPT_ENABLE;
 return;
}
static noinline void smbus_FillCpuInfoTable(void)
{
 int i;
 CpuInfo *pentry;
 memset (&smbus_cpuinfotable, 0, sizeof(smbus_cpuinfotable));
 if (SMP_NUM_CPUS > 1024) {
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_FillCpuInfoTable: ERROR !!! current CPUs number exceeds the max. supported value (current = %d, max = %d)\n", (int)(jiffies-jiffies0), (int)SMP_NUM_CPUS, 1024); } while (0);
  return;
 }
 for (i=0; i < SMP_NUM_CPUS; i++)
 {
  pentry = &smbus_cpuinfotable[i];
  pentry->DenseCpuNr = i;
  pentry->regs1Valid = 0;
  pentry->regs2Valid = 0;
  pentry->regs3Valid = 0;
  pentry->regs4Valid = 0;
  pentry->BrandStringValid = 0;
  pentry->NrCoresAMDValid = 0;
  pentry->LocalApicSupported = 0;
  pentry->MachineCheckArchitectureSupported = 0;
  pentry->PrimaryLogicalCpu = 0;
  pentry->BootstrapCpu = 0;
  pentry->ApicGlobalEnable = 0;
  pentry->x2ApicMode = 0;
  pentry->ApicIdValid = 0;
  smbus_do_ReadCpuInfo(pentry);
  if (pentry->regs0.ebx == 0x756E6547)
  {
   pentry->Vendor = 0x01;
   if (pentry->regs4Valid)
   {
    pentry->NrCores = (unsigned short) (1 + (((pentry->regs4.eax) >> 26) & 0x3F));
   }
  }
  else
  {
   pentry->Vendor = 0x02;
   if (pentry->NrCoresAMDValid)
   {
    pentry->NrCores = (unsigned short) (1 + (((pentry->NrCoresAMD.ecx) >> 0) & 0xFF));
   }
  }
 }
 if (smbusDebug> 0)
 {
  for (i=0; i < SMP_NUM_CPUS; i++)
  {
   pentry = &smbus_cpuinfotable[i];
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CPU%02d: sparse CPU# = %02d, dense CPU# = %02d\n", (int)(jiffies-jiffies0), i, pentry->SparseCpuNr, pentry->DenseCpuNr); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs1Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs1Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs2Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs2Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs3Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs3Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs4Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs4Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandStringValid       = %d\n", (int)(jiffies-jiffies0), pentry->BrandStringValid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NrCoresAMDValid        = %d\n", (int)(jiffies-jiffies0), pentry->NrCoresAMDValid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       CheckArchSupported     = %d\n", (int)(jiffies-jiffies0), pentry->MachineCheckArchitectureSupported); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       LocalApicSupported     = %d\n", (int)(jiffies-jiffies0), pentry->LocalApicSupported); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       PrimaryLogicalCpu      = %d\n", (int)(jiffies-jiffies0), pentry->PrimaryLogicalCpu); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       LocalApicIdInitial     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->LocalApicIdInitial); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Vendor                 = %d\n", (int)(jiffies-jiffies0), pentry->Vendor); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NrCores                = %d\n", (int)(jiffies-jiffies0), pentry->NrCores); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NumberLogicalCpus      = %d\n", (int)(jiffies-jiffies0), pentry->NumberLogicalCpus); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 0 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 1 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 2 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 3 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 4 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NrCoresAMD     EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       MaxExtentions  EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandString1   EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandString2   EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandString3   EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicBaseMsr register   = 0x%016lX\n", (int)(jiffies-jiffies0), (unsigned long)pentry->ApicBaseMsr); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicBaseAddress        = 0x%016lX\n", (int)(jiffies-jiffies0), (unsigned long)pentry->ApicBaseAddress); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       x2ApicLocalApicId      = 0x%016lX\n", (int)(jiffies-jiffies0), (unsigned long)pentry->x2ApicLocalApicId); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       MappedVirtualAddress   = 0x%p\n", (int)(jiffies-jiffies0), pentry->ApicVirtualAddress); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BootstrapCpu           = %d\n", (int)(jiffies-jiffies0), pentry->BootstrapCpu); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicGlobalEnable       = %d\n", (int)(jiffies-jiffies0), pentry->ApicGlobalEnable); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       x2ApicMode             = %d\n", (int)(jiffies-jiffies0), pentry->x2ApicMode); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicId is valid        = %d\n", (int)(jiffies-jiffies0), pentry->ApicIdValid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicId                 = 0x%08X\n", (int)(jiffies-jiffies0), pentry->ApicId); } while (0);
  }
 }
 return;
}
noinline void smbus_GetCpuError_callback(void *pCpuErrInfo)
{
 int sparse;
 int dense;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (((CpuErrorInfo *)pCpuErrInfo)->DenseCpuNr == dense)
 {
  smbus_ReadCpuErrorInfo((CpuErrorInfo *)pCpuErrInfo);
 }
 return;
}
static noinline void smbus_do_GetCpuError(CpuErrorInfo *pCpuErrInfo)
{
 int sparse;
 int dense;
 PREEMPT_DISABLE;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pCpuErrInfo->DenseCpuNr == dense)
 {
  smbus_ReadCpuErrorInfo((CpuErrorInfo *)pCpuErrInfo);
 } else {
  SMP_CALL_FUNCTION(smbus_GetCpuError_callback, (void *)pCpuErrInfo, 1, 1);
 }
 PREEMPT_ENABLE;
 return;
}
static noinline void smbus_ReadCpuErrorInfo(CpuErrorInfo *pCpuErrInfo)
{
 int i;
 IOCTLDATA_CORR_CPU_ERROR *pError = (IOCTLDATA_CORR_CPU_ERROR *)(pCpuErrInfo->pCpuError);
 unsigned long long IA32_MCi_STATUS;
 unsigned long long IA32_MCi_ADDR;
 unsigned short MCAErrorCode;
 pCpuErrInfo->McgCap = smbus_ReadMsr (0x179);
 pCpuErrInfo->McgStatus = smbus_ReadMsr (0x17A);
 pCpuErrInfo->NrErrorBanks = ((unsigned char)(((pCpuErrInfo->McgCap) >> 0) & 0xff));
 pCpuErrInfo->ErrorAvailable = 0;
 for (i=0; i < pCpuErrInfo->NrErrorBanks; i++)
 {
  pCpuErrInfo->MsrAddrMCiStatus = (0x401+((i)*4));
  pCpuErrInfo->MsrAddrMCiAddr = (0x402+((i)*4));
  IA32_MCi_STATUS = smbus_ReadMsr ((0x401+((i)*4)));
  if (((unsigned char)(((IA32_MCi_STATUS) >> 63) & 1)))
  {
   pCpuErrInfo->ErrorAvailable = 1;
   pError->IA32MCiStatus = IA32_MCi_STATUS;
   pError->Bank = i;
   pError->ErrorCode = ((unsigned short)(((IA32_MCi_STATUS) >> 0) & 0xffff));
   pError->Overflow = ((unsigned char)(((IA32_MCi_STATUS) >> 62) & 1));
   pError->Uncorrectable = ((unsigned char)(((IA32_MCi_STATUS) >> 61) & 1));
   MCAErrorCode = pError->ErrorCode;
   if (((unsigned char)(((IA32_MCi_STATUS) >> 58) & 1)))
   {
    IA32_MCi_ADDR = smbus_ReadMsr ((0x402+((i)*4)));
    pError->AddressLow = (unsigned int) (IA32_MCi_ADDR & 0xffffffff);
    pError->AddressHigh = (unsigned int) (IA32_MCi_ADDR >> 32);
   } else {
    pError->AddressLow = pError->AddressHigh = 0xffffffff;
   }
   pError->CacheLevel = (unsigned char)((((MCAErrorCode) >> 0) & 0x3));
   pError->RequestType = (unsigned char)((((MCAErrorCode) >> 4) & 0xf));
   pError->TransactionType = (unsigned char)((((MCAErrorCode) >> 2) & 0x3));
   pError->ParticipationLevel = (unsigned char)((((MCAErrorCode) >> 9) & 0x3));
   pError->Timeout = (unsigned char)((((MCAErrorCode) >> 8) & 0x1));
   pError->MemIo = (unsigned char)((((MCAErrorCode) >> 2) & 0x3));
   if ((((MCAErrorCode) & 0xff00) == 0x0100))
   {
    pError->ErrorType = CPUERR_TYPE_CACHE_ERROR;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   else if ((((MCAErrorCode) & 0xf800) == 0x0800))
   {
    pError->ErrorType = CPUERR_TYPE_BUS_ERROR;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   else if ((((MCAErrorCode) & 0xfff0) == 0x0010))
   {
    pError->ErrorType = CPUERR_TYPE_TLB_ERROR;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   else
   {
    pError->ErrorType = CPUERR_TYPE_UNCLASSIFIED;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   break;
  }
 }
 return;
}
static noinline unsigned long long smbus_ReadMsr (unsigned int address)
{
 volatile unsigned int reg_eax;
 volatile unsigned int reg_edx;
 ASMX86("rdmsr"
  : "=a" (reg_eax), "=d" (reg_edx)
  : "c" (address));
 return (((unsigned long long)reg_edx << 32) | (unsigned long long)reg_eax);
}
static noinline void smbus_WriteMsr (unsigned int address, unsigned long long data)
{
 volatile unsigned int DataLow;
 volatile unsigned int DataHigh;
 DataLow = (unsigned int) (data & (unsigned long long)0x0FFFFFFFF);
 DataHigh = (unsigned int) (data >> 32);
 ASMX86("wrmsr"
  :
  : "c" (address), "a" (DataLow), "d" (DataHigh));
}
static noinline void smbus_CpuId (unsigned int address, CpuIdRegs *regs)
{
 ASMX86(PUSH_RAX);
 ASMX86(PUSH_RBX);
 ASMX86(PUSH_RCX);
 ASMX86(PUSH_RDX);
 ASMX86(RESET_RCX);
 ASMX86("cpuid"
  : "=a" (regs->eax), "=b" (regs->ebx), "=c" (regs->ecx), "=d" (regs->edx)
  : "a" (address));
 ASMX86(POP_RDX);
 ASMX86(POP_RCX);
 ASMX86(POP_RBX);
 ASMX86(POP_RAX);
}
static noinline int smbus_SwitchMux(unsigned int DeviceHandle, unsigned char * pDeviceAddress);
static noinline int smbus_ClearStatus(void);
static noinline int smbus_WaitHostBusy(void);
static noinline int smbus_WaitCmdDone(void);
static noinline void smbus_ReleaseBus(void);
noinline unsigned int smbus_ReadData(unsigned char DeviceAddress, unsigned char StartOffset, unsigned char * pReturnBuffer, unsigned int BytesToRead)
{
 unsigned int ReturnDataSize = 0;
 unsigned char Data = 0;
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadData: read %d SM bus data bytes from %02X:%02X\n", (int)(jiffies-jiffies0), BytesToRead, DeviceAddress, StartOffset); } while (0);
 if (my_Chipset == CS_UNKNOWN || 0 == BytesToRead || NULL == pReturnBuffer)
  return 0;
 if (smbus_ReadByte (DeviceAddress, StartOffset, &Data, 0))
 {
  unsigned char * pData = (unsigned char *)pReturnBuffer;
  unsigned int Offset = StartOffset+1;
  *pData++ = Data;
  ReturnDataSize = 1;
  BytesToRead--;
  while (BytesToRead)
  {
   if (!(Offset < 256))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## FATAL ERROR: smbus_ReadData: Offset exceeds 255 while reading data!\n", (int)(jiffies-jiffies0)); } while (0);
    break;
   }
   if (!smbus_ReadByte (DeviceAddress, (unsigned char)Offset, &Data, 1))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadData: ERROR while reading data bytes, abort loop\n", (int)(jiffies-jiffies0)); } while (0);
    break;
   }
   *pData++ = Data;
   Offset++;
   ReturnDataSize++;
   BytesToRead--;
  }
 }
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadData: %d bytes read from SM bus\n", (int)(jiffies-jiffies0), ReturnDataSize); } while (0);
 return ReturnDataSize;
}
noinline unsigned int smbus_WriteData(unsigned char DeviceAddress, unsigned char StartOffset, unsigned char * pWriteData, unsigned int BytesToWrite)
{
 unsigned int WriteDataSize = 0;
 unsigned int Offset = StartOffset;
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteData: write %d SM bus data bytes to %02X:%02X...\n", (int)(jiffies-jiffies0), BytesToWrite, DeviceAddress, StartOffset); } while (0);
 if (my_Chipset == CS_UNKNOWN || 0 == BytesToWrite || NULL == pWriteData)
  return WriteDataSize;
 while (BytesToWrite)
 {
  if (!(Offset < 256))
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## FATAL ERROR: smbus_WriteData: Offset exceeds 255 while writing data!\n", (int)(jiffies-jiffies0)); } while (0);
   break;
  }
  if (smbus_WriteByte (DeviceAddress, (unsigned char)Offset, *pWriteData, 0))
  {
   WriteDataSize++;
   BytesToWrite--;
   Offset++;
   pWriteData++;
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteData: ERROR while writing data bytes, abort loop\n", (int)(jiffies-jiffies0)); } while (0);
   break;
  }
 }
 if (0 == BytesToWrite)
  do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteData: %d bytes written to SM bus\n", (int)(jiffies-jiffies0), WriteDataSize); } while (0);
 else
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteData: Failed to write data byte 0x%02X:0x%02X!\n", (int)(jiffies-jiffies0), DeviceAddress, Offset); } while (0);
 return WriteDataSize;
}
noinline int smbus_OpenDevice(unsigned int * pDeviceHandle, SMBUS_DEVICE_ADDRESS_DATA_ST *psmdev, unsigned int size)
{
#ifdef KERNEL30
 static DEFINE_SPINLOCK(smbus_handle_lock);
#else
 static spinlock_t smbus_handle_lock = SPIN_LOCK_UNLOCKED;
#endif
 SMBUS_DEVICE_ADDRESS_DATA_ST *ptmp;
 unsigned int Handle;
 int Status = 0;
 int Found = 0;
 *pDeviceHandle = (uint32_t)-1;
 if ((pDeviceHandle == NULL) || (psmdev == NULL) || (size == 0))
  return 1;
 spin_lock(&smbus_handle_lock);
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: look whether device already exists in handle table\n", (int)(jiffies-jiffies0)); } while (0);
 for (Handle=0; !Found && Handle < 256; Handle++)
 {
  if (OpenDevices[Handle] != NULL)
  {
   ptmp = (SMBUS_DEVICE_ADDRESS_DATA_ST *) OpenDevices[Handle];
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice:   check device at handle %04X (addr 0x%02X)...\n", (int)(jiffies-jiffies0), Handle, ptmp->iod_open.DeviceAddress); } while (0);
   if (0 == memcmp ((unsigned char *)psmdev, (unsigned char *)ptmp, size))
   {
    Found = 1;
    *pDeviceHandle = Handle;
    do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: device already exists, return handle %04X\n", (int)(jiffies-jiffies0), *pDeviceHandle); } while (0);
   }
  }
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: create new entry\n", (int)(jiffies-jiffies0)); } while (0);
 if (!Found)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: device not yet existing in handle table, create new entry\n", (int)(jiffies-jiffies0)); } while (0);
  for (Handle=0; !Found && Handle < 256; Handle++)
  {
   if (OpenDevices[Handle] == NULL)
   {
    OpenDevices[Handle] = OpenDevicesPersist[Handle];
    memcpy (OpenDevices[Handle], psmdev, size);
    *pDeviceHandle = Handle;
    Found = 1;
    do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: new handle %04X assigned\n", (int)(jiffies-jiffies0), *pDeviceHandle); } while (0);
   }
  }
  if (Handle >= 256)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: ## ERROR! OpenDevices table overflow!\n", (int)(jiffies-jiffies0)); } while (0);
   Status = 3;
  }
 }
 spin_unlock(&smbus_handle_lock);
 return Status;
}
noinline int smbus_CloseDevice(unsigned int DeviceHandle)
{
 do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_CloseDevice: close device handle %d\n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
 if (DeviceHandle >= 256)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_CloseDevice: ## ERROR! illegal device handle (%d)!\n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
  return 2;
 }
 else if (OpenDevices[DeviceHandle] == NULL)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_CloseDevice: ## ERROR! no device opened with handle %d!\n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
  return 2;
 }
 else
 {
  memset(OpenDevices[DeviceHandle], 0, sizeof(SMBUS_DEVICE_ADDRESS_DATA_ST));
  OpenDevices[DeviceHandle] = NULL;
  return 0;
 }
}
noinline int smbus_ReadDevice(unsigned int DeviceHandle, unsigned char Offset, unsigned int BytesToRead, unsigned char * pReturnBuffer, unsigned int * pBytesRead)
{
 int Status = 0;
 unsigned char DeviceAddress;
 *pBytesRead = 0;
 Status = smbus_SwitchMux (DeviceHandle, &DeviceAddress);
 if (0 == Status)
 {
  *pBytesRead = smbus_ReadData (DeviceAddress, Offset, pReturnBuffer, BytesToRead);
  if (0 == *pBytesRead)
   Status = 1;
 }
 return Status;
}
noinline int smbus_WriteDevice (unsigned int DeviceHandle, unsigned char Offset, unsigned int BytesToWrite, unsigned char * pWriteBuffer)
{
 int Status = 0;
 unsigned char DeviceAddress;
 Status = smbus_SwitchMux (DeviceHandle, &DeviceAddress);
 if (0 == Status)
 {
  unsigned int BytesWritten = smbus_WriteData (DeviceAddress, Offset, pWriteBuffer, BytesToWrite);
  if (BytesToWrite != BytesWritten)
   Status = 1;
 }
 return Status;
}
noinline int smbus_ReadByte(unsigned char DeviceAddress, unsigned char Offset, unsigned char * pData, int NotUseOffset)
{
 unsigned char ControlCmd;
 int Success = 0;
 unsigned int RetryCnt;
 if (!my_SMBusBaseAddress || !pData)
  return 0;
 ControlCmd = NotUseOffset ? ((unsigned char)(1<<2)) : ((unsigned char)(2<<2));
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadByte: read data byte from 0x%02X:0x%02X%s\n", (int)(jiffies-jiffies0), DeviceAddress, Offset, NotUseOffset ? " - without offset" : ""); } while (0);
 for (RetryCnt=0; !Success && RetryCnt < 3; RetryCnt++)
 {
 if (!smbus_WaitHostBusy())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_ReadByte: WaitHostBusy() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else if (!smbus_ClearStatus())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_ReadByte: ClearStatus() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadByte: reading data byte...\n", (int)(jiffies-jiffies0)); } while (0);
   outb_p(((DeviceAddress | ((unsigned char)(1<<0)))), (int)(my_SMBusBaseAddress + (((unsigned char)0x04))));
   if (!NotUseOffset)
    outb_p((Offset), (int)(my_SMBusBaseAddress + (((unsigned char)0x03))));
   outb_p((ControlCmd | ((unsigned char)(1<<6))), (int)(my_SMBusBaseAddress + (((unsigned char)0x02))));
   Success = smbus_WaitCmdDone();
   if (Success)
   {
    *pData = inb_p((int)(my_SMBusBaseAddress + (((unsigned char)0x05))));
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadByte: data byte successfully read: 0x%02X!!\n", (int)(jiffies-jiffies0), *pData); } while (0);
   }
   else
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## WARNING: smbus_ReadByte: WaitCmdDone() failed!\n", (int)(jiffies-jiffies0)); } while (0);
    NotUseOffset = 0;
    if(0 != Offset)
    ControlCmd = ((unsigned char)(2<<2));
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## RETRY\n", (int)(jiffies-jiffies0)); } while (0);
   }
  }
 smbus_ReleaseBus();
 }
 return Success;
}
noinline int smbus_WriteByte(unsigned char DeviceAddress, unsigned char Offset, unsigned char Data, int NotUseOffset)
{
 unsigned char ControlCmd;
 int Success = 0;
 unsigned int RetryCnt;
 if (!my_SMBusBaseAddress)
  return 0;
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: write data byte 0x%02X to 0x%02X:0x%02X%s\n", (int)(jiffies-jiffies0), Data, DeviceAddress, Offset, NotUseOffset ? " - without offset" : ""); } while (0);
 ControlCmd = NotUseOffset ? ((unsigned char)(1<<2)) : ((unsigned char)(2<<2));
 for (RetryCnt = 0; !Success && RetryCnt < 3; RetryCnt++)
 {
  if (RetryCnt)
   do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "## WARNING: smbus_WriteByte: RETRY %d!!!\n", (int)(jiffies-jiffies0),RetryCnt); } while (0);
  if (!smbus_WaitHostBusy())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteByte: WaitHostBusy() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else if (!smbus_ClearStatus())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteByte: ClearStatus() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: writing data byte...\n", (int)(jiffies-jiffies0)); } while (0);
   outb_p(((DeviceAddress | ((unsigned char)(0<<0)))), (int)(my_SMBusBaseAddress + (((unsigned char)0x04))));
   if (!NotUseOffset)
   {
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set Offset %02x\n", (int)(jiffies-jiffies0),Offset); } while (0);
    outb_p((Offset), (int)(my_SMBusBaseAddress + (((unsigned char)0x03))));
   }
   else
   {
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set (data) %02x\n", (int)(jiffies-jiffies0),Data); } while (0);
    outb_p((Data), (int)(my_SMBusBaseAddress + (((unsigned char)0x03))));
   }
   do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set Data   %02x\n", (int)(jiffies-jiffies0),Data); } while (0);
   outb_p((Data), (int)(my_SMBusBaseAddress + (((unsigned char)0x05))));
   do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set Cmd    %02x\n", (int)(jiffies-jiffies0), ControlCmd | ((unsigned char)(1<<6))); } while (0);
   outb_p((ControlCmd | ((unsigned char)(1<<6))), (int)(my_SMBusBaseAddress + (((unsigned char)0x02))));
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: START sleep\n", (int)(jiffies-jiffies0)); } while (0);
   set_current_state(TASK_UNINTERRUPTIBLE);
   schedule_timeout((10*HZ)/1000);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: STOP  sleep\n", (int)(jiffies-jiffies0)); } while (0);
   Success = smbus_WaitCmdDone();
   if (Success) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Data byte successfully written\n", (int)(jiffies-jiffies0)); } while (0);
   smbus_ReleaseBus();
  }
 }
 if(!Success)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteByte: failed after retries!\n", (int)(jiffies-jiffies0)); } while (0);
 }
 return Success;
}
noinline int smbus_SwitchMux(unsigned int DeviceHandle, unsigned char * pDeviceAddress)
{
 int Status = 0;
 int Abort = 0;
 unsigned int i;
 IOCTLDATA_SMBUS_OPEN_DEVICE *pAddr;
 if (DeviceHandle >= 256)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: ## ERROR! Illegal device handle (exceeds MAX_OPEN_DEVICES)!\n", (int)(jiffies-jiffies0)); } while (0);
  Status = 2;
 }
 else if ((pAddr = (IOCTLDATA_SMBUS_OPEN_DEVICE *)OpenDevices[DeviceHandle]) == NULL)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: ## ERROR! Illegal device handle (device not opened)!\n", (int)(jiffies-jiffies0)); } while (0);
  Status = 2;
 }
 else
 {
  *pDeviceAddress = pAddr->DeviceAddress;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: found DeviceAddress = 0x%02X\n", (int)(jiffies-jiffies0), *pDeviceAddress); } while (0);
  for (i = 0; !Abort && (i < 10) && (pAddr->MuxAddr[i].Address != 0xFF); i++)
  {
   SMBUS_MUX_ADDR *pMuxAddr = &pAddr->MuxAddr[i];
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "                    MUX detected: Addr=0x%02X, Prot=%d, AndMask=0x%02X, OrMask=0x%02X\n", (int)(jiffies-jiffies0), pMuxAddr->Address, pMuxAddr->Protocol, pMuxAddr->AndMask, pMuxAddr->OrMask); } while (0);
   switch (pMuxAddr->Protocol)
   {
   case 0:
    {
     unsigned char MuxByte;
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "                    MUX protocol is \"WriteByte\"\n", (int)(jiffies-jiffies0)); } while (0);
     if (!smbus_ReadByte (pMuxAddr->Address, 0, &MuxByte, 1))
      Abort = 1;
     else
     {
      MuxByte = (MuxByte & pMuxAddr->AndMask) | pMuxAddr->OrMask;
      if (!smbus_WriteByte (pMuxAddr->Address, 0, MuxByte, 1))
       Abort = 1;
     }
     do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: MUX at level %d (addr 0x%02X) switched\n", (int)(jiffies-jiffies0), i+1, pMuxAddr->Address); } while (0);
    }
    break;
   default:
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: ## FATAL ERROR: Unsupported MUX protocol (%d)\n", (int)(jiffies-jiffies0), pMuxAddr->Protocol); } while (0);
    Abort = 1;
    break;
   }
  }
 }
 if (Abort)
  Status = 1;
 return Status;
}
noinline int smbus_ClearStatus(void)
{
 unsigned char Status = inb_p((int)(my_SMBusBaseAddress + (((unsigned char)0x00)))) & ~((unsigned char)(1<<6));
 unsigned int RetryCnt, WaitCnt;
 do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: Status = 0x%02X\n", (int)(jiffies-jiffies0), Status); } while (0);
 Status &= ((((unsigned char)(1<<2)) | ((unsigned char)(1<<3)) | ((unsigned char)(1<<4))) | ((unsigned char)(1<<0)) | ((unsigned char)(1<<1)));
 for (RetryCnt = 0; Status && (RetryCnt < 3); RetryCnt++)
 {
  if (RetryCnt)
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: ## WARNING: RETRY!!\n", (int)(jiffies-jiffies0)); } while (0);
  for (WaitCnt = 0; Status && WaitCnt < 100; WaitCnt++)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: Status not zero, reset it...\n", (int)(jiffies-jiffies0)); } while (0);
   outb_p(((((((unsigned char)(1<<2)) | ((unsigned char)(1<<3)) | ((unsigned char)(1<<4))) | ((unsigned char)(1<<0)) | ((unsigned char)(1<<1))))), (int)(my_SMBusBaseAddress + (((unsigned char)0x00))));
   udelay (10);
   Status = inb_p((int)(my_SMBusBaseAddress + (((unsigned char)0x00))));
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: Status after reset = 0x%02X\n", (int)(jiffies-jiffies0), Status); } while (0);
   Status &= ((((unsigned char)(1<<2)) | ((unsigned char)(1<<3)) | ((unsigned char)(1<<4))) | ((unsigned char)(1<<0)) | ((unsigned char)(1<<1)));
   if (Status & ((unsigned char)(1<<0)))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: ## WARNING: BUSY while clearing status - send KILL command\n", (int)(jiffies-jiffies0)); } while (0);
    outb_p((((unsigned char)(1<<1))), (int)(my_SMBusBaseAddress + (((unsigned char)0x02))));
    set_current_state(TASK_UNINTERRUPTIBLE);
    schedule_timeout((100*HZ)/1000);
    outb_p((0), (int)(my_SMBusBaseAddress + (((unsigned char)0x02))));
    break;
   }
   if (Status)
   {
    set_current_state(TASK_UNINTERRUPTIBLE);
    schedule_timeout((1*HZ)/1000);
   }
  }
 }
 return (Status == 0);
}
noinline int smbus_WaitHostBusy(void)
{
 unsigned char Status;
 unsigned int i;
 unsigned char StatusMask = (my_Chipset == CS_INTEL_ICH) ? (((unsigned char)(1<<6)) | ((unsigned char)(1<<0)))
             : ((unsigned char)(1<<0));
 for (i = 0; i < 35; i++)
 {
  Status = inb_p((int)(my_SMBusBaseAddress + (((unsigned char)0x00))));
  if (Status & StatusMask)
  {
   set_current_state(TASK_UNINTERRUPTIBLE);
   schedule_timeout((1*HZ)/1000);
  }
  else
  {
   return 1;
  }
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitHostBusy: ## ERROR: Timeout while waiting host busy, status=0x%02X!\n", (int)(jiffies-jiffies0), Status); } while (0);
 return 0;
}
noinline int smbus_WaitCmdDone(void)
{
 int Done = 0;
 int Success = 0;
 unsigned char Status = 0;
 unsigned int i;
 int k;
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitCmdDone: waiting until command done...\n", (int)(jiffies-jiffies0)); } while (0);
 for (i = 0; !Done && i < ((1000/50)*35); i++)
 {
 do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "CSmbus::WaitCmdDone: sleep %d usec.\n", (int)(jiffies-jiffies0), 50); } while (0);
 udelay (50);
  Status = inb_p((int)(my_SMBusBaseAddress + (((unsigned char)0x00))));
  do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitCmdDone: Status = 0x%02X, retry count = %d\n", (int)(jiffies-jiffies0), Status, i); } while (0);
  if (Status & (((unsigned char)(1<<1)) | ((unsigned char)(1<<2)) | ((unsigned char)(1<<3)) | ((unsigned char)(1<<4))))
  {
   Done = 1;
   if (!(Status & (((unsigned char)(1<<2)) | ((unsigned char)(1<<3)) | ((unsigned char)(1<<4)))))
    Success = 1;
   else
   {
    unsigned char * pErrMsg;
    if (Status & ((unsigned char)(1<<2)))
     pErrMsg = "device error";
    else if (Status & ((unsigned char)(1<<3)))
     pErrMsg = "bus error";
    else if (Status & ((unsigned char)(1<<4)))
     pErrMsg = "kill";
    else
    {
     pErrMsg = "## Unknown error ##";
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitCmdDone: SM BUS ERROR <<%s>>, status=0x%02X!\n", (int)(jiffies-jiffies0), pErrMsg, Status); } while (0);
  for (k=0;k<50;k++)
  {
   if(Status & ((unsigned char)(1<<0)))
   {
    Status = inb_p((int)(my_SMBusBaseAddress + (((unsigned char)0x00))));
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "CSmbus::WaitCmdDone: wait for Status not busy (%d 0x%02X)\n", (int)(jiffies-jiffies0),k,Status); } while (0);
    udelay (5);
   }
   else break;
  }
   }
  }
 }
 if (!Done)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitHostBusy: ## ERROR: timeout while waiting for transaction done (status=0x%02X)!\n", (int)(jiffies-jiffies0), Status); } while (0);
 }
 return Success;
}
noinline void smbus_ReleaseBus(void)
{
 if(CS_INTEL_ICH == my_Chipset)
 {
    outb_p((((unsigned char)(1<<6))), (int)(my_SMBusBaseAddress + (((unsigned char)0x00))));
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "CSmbus::ReleaseBus: Release ICH Semaphore\n", (int)(jiffies-jiffies0)); } while (0);
 }
}
  
